dnl aclocal.m4 generated automatically by aclocal 1.4a

dnl Copyright (C) 1994, 1995-8, 1999 Free Software Foundation, Inc.
dnl This file is free software; the Free Software Foundation
dnl gives unlimited permission to copy and/or distribute it,
dnl with or without modifications, as long as this notice is preserved.

dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY, to the extent permitted by law; without
dnl even the implied warranty of MERCHANTABILITY or FITNESS FOR A
dnl PARTICULAR PURPOSE.



AC_DEFUN(AC_SS_CONFIGURE_MAIN,
	[
		AC_CHECKING(kvirc build configuration...)
		AC_SS_FIND_X
		AC_SS_FIND_QT
		AC_SS_FIND_JPEG
		AC_SS_FIND_DL
		AC_SS_CHECK_PTHREAD
		AC_SS_CHECK_LOCALIZE
		AC_SS_SET_USEFUL_VARIABLES
		AC_SS_PRINT_FINAL_RESULTS
	]
)


AC_DEFUN(AC_SS_PRINT_FINAL_RESULTS,
	[
		AC_MSG_RESULT([--------------------------------------------------])
		AC_MSG_RESULT([--- Current build configuration:])
		AC_MSG_RESULT([--------------------------------------------------])
		AC_MSG_RESULT([--- X libraries are in $SS_X_LIBRARY_DIR])
		AC_MSG_RESULT([--- X headers are in $SS_X_INCLUDE_DIR])
		AC_MSG_RESULT([--- Qt library is in $SS_QT_LIBRARY_DIR])
		AC_MSG_RESULT([--- Qt headers are in $SS_QT_INCLUDE_DIR])
		AC_MSG_RESULT([--- Qt meta-object compiler path is $SS_QT_MOC])
		AC_MSG_RESULT([--- Compilation flags:])
		AC_MSG_RESULT([--- RPATH is $SS_FLAGS_RPATH])
		AC_MSG_RESULT([--- INCLUDE DIRS are $SS_FLAGS_INCDIRS])
		AC_MSG_RESULT([--- LIBRARY DIRS are $SS_FLAGS_LIBDIRS])
		AC_MSG_RESULT([--- LIBRARIES are $SS_FLAGS_LIBLINK])
		AC_MSG_RESULT([--- Jpeg library : $SS_HAVE_LIBJPEG])
		AC_MSG_RESULT([--- Relative installation directories:])
		AC_MSG_RESULT([--- Binaries : $bindir])
		AC_MSG_RESULT([--- Libraries : $libdir])
		AC_MSG_RESULT([--- Images : $imagedir])
		AC_MSG_RESULT([--- Help text files : $helpdir])
		AC_MSG_RESULT([--- Default config files : $configdir])
		AC_MSG_RESULT([--- Internationalisation : $localedir])
		AC_MSG_RESULT([--- Global KVIrc dir : $globalkvircdir])
		AC_MSG_RESULT([--- Man page : $mandir])
		AC_MSG_RESULT([--- Plugin directory : $pluglibdir])
		AC_MSG_RESULT([--------------------------------------------------])
	]
)

AC_DEFUN(AC_SS_SET_USEFUL_VARIABLES,
	[

		SS_FLAGS_RPATH="-rpath $SS_QT_LIBRARY_DIR -rpath $SS_X_LIBRARY_DIR -rpath $libdir"
 		SS_FLAGS_INCDIRS="-I$SS_QT_INCLUDE_DIR -I$SS_X_INCLUDE_DIR -D_REENTRANT"
		SS_FLAGS_LIBDIRS="-L$SS_QT_LIBRARY_DIR -L$SS_X_LIBRARY_DIR"
		SS_FLAGS_LIBLINK="-lqt $SS_X_EXTRA_LIBS -lXext -lX11 -lpthread" 
		AC_PREFIX_DEFAULT(/usr/local) 	
		imagedir="\${exec_prefix}/share/kvirc/pics" 	
		helpdir="\${exec_prefix}/share/kvirc/help/en" 	
		configdir="\${exec_prefix}/share/kvirc/config" 	
		localedir="\${exec_prefix}/share/kvirc/locale" 	
		mandir="\${exec_prefix}/man/man1"
		globalkvircdir="\${exec_prefix}/share/kvirc"
		pluglibdir="\${exec_prefix}/share/kvirc/plugins"

		if test -n "$SS_HAVE_LIBJPEG"; then
			SS_FLAGS_LIBLINK="$SS_FLAGS_LIBLINK -ljpeg"
		fi

		if test -n "$SS_HAVE_LIBDL"; then
			SS_FLAGS_LIBLINK="$SS_FLAGS_LIBLINK -export-dynamic -ldl"
			SS_PLUGINS_DIRECTORY_COMPILE="plugins"
		else
			SS_PLUGINS_DIRECTORY_COMPILE=""
		fi

		AC_SUBST(SS_PLUGINS_DIRECTORY_COMPILE)

		AC_ARG_WITH(solaris-libs, [  --with-solaris-libs     Specifies to link also to lsocket,lresolv and lnsl],SS_FLAGS_LIBLINK="$SS_FLAGS_LIBLINK -lnsl -lsocket -lresolv")

		AC_ARG_WITH(pipes, [  --with-pipes            Specifies to use pipes for compilation],SS_FLAGS_INCDIRS="-pipe $SS_FLAGS_INCDIRS")

		if test -n "$SS_X_EXTRA_GCC_FLAGS"; then
			SS_FLAGS_INCDIRS="$X_CFLAGS $SS_FLAGS_INCDIRS"
		fi

		AC_ARG_WITH(ignore-sigalarm, [  --with-ignore-sigalarm  Specifies to ignore SIGALARM in all threads],SS_COMPILE_IGNORE_SIGALARM="true")

		if test -n "$SS_COMPILE_IGNORE_SIGALARM"; then
			AC_DEFINE(COMPILE_NEED_IGNORE_SIGALARM)
		fi

		AC_ARG_WITH(own-inet-aton, [  --with-own-inet-aton    Specifies to use own inet aton implementation],SS_COMPILE_USE_OWN_INET_ATON="true")
		AC_ARG_WITH(own-inet-ntoa, [  --with-own-inet-ntoa    Specifies to use own inet ntoa implementation],SS_COMPILE_USE_OWN_INET_NTOA="true")

		if test -n "$SS_COMPILE_USE_OWN_INET_ATON"; then
			AC_DEFINE(COMPILE_NEED_OWN_INET_ATON)
		fi

		if test -n "$SS_COMPILE_USE_OWN_INET_NTOA"; then
			AC_DEFINE(COMPILE_NEED_OWN_INET_NTOA)
		fi

		if test -n "$SS_X_EXTRA_LDD_FLAGS"; then
			SS_FLAGS_L="$SS_X_EXTRA_LDD_FLAGS $SS_FLAGS_LIBDIRS"
		fi

		build_date=`date`
		AC_DEFINE_UNQUOTED(BUILD_DATE,"$build_date")

		AC_ARG_WITH(i386-asm, [  --with-i386-asm         Specifies to compile x86 assembly optimisations],SS_COMPILE_i386_ASM="true")


		if test -n "$SS_COMPILE_i386_ASM"; then
			AC_MSG_CHECKING(target system CPU)
			if test "$target_cpu" = "i386"; then
				AC_MSG_RESULT(i386 : compiling asm code)
				AC_DEFINE(HAVE_i386_BASED_CPU)
			else
				if test "$target_cpu" = "i486"; then
					AC_MSG_RESULT(i486 : compiling asm code)
					AC_DEFINE(HAVE_i386_BASED_CPU)
				else
					if test "$target_cpu" = "i586"; then
						AC_MSG_RESULT(i586 : compiling asm code)
						AC_DEFINE(HAVE_i386_BASED_CPU)
					else
						if test "$target_cpu" = "i686"; then
							AC_MSG_RESULT(i686 : compiling asm code)
							AC_DEFINE(HAVE_i386_BASED_CPU)
						else
							AC_MSG_RESULT($target_cpu , no i386 optimisations)
						fi
					fi
				fi
			fi
		fi

		AC_SUBST(SS_FLAGS_RPATH)
		AC_SUBST(SS_FLAGS_LIBDIRS)
		AC_SUBST(SS_FLAGS_LIBLINK)
		AC_SUBST(SS_FLAGS_INCDIRS)
		AC_SUBST(imagedir)
		AC_SUBST(helpdir)
		AC_SUBST(configdir)
		AC_SUBST(localedir)
		AC_SUBST(globalkvircdir)
		AC_SUBST(pluglibdir)
	]
)




AC_DEFUN(AC_FIND_FILE,[
	$3=NO
	for i in $2; do
		for j in $1; do
			if test -r "$i/$j"; then
				$3=$i
				break 2
			fi
		done
	done
])

AC_DEFUN(AC_CHECK_BOOL,
[
	AC_MSG_CHECKING([for bool])
        AC_CACHE_VAL(ac_cv_have_bool,
        [
		AC_LANG_CPLUSPLUS
          	AC_TRY_COMPILE([],
                 [bool aBool = true;],
                 [ac_cv_have_bool="yes"],
                 [ac_cv_have_bool="no"])
        ]) dnl end AC_CHECK_VAL
        AC_MSG_RESULT($ac_cv_have_bool)
        if test "$ac_cv_have_bool" = "yes"; then
        	AC_DEFINE(HAVE_BOOL) 
        fi 
])

AC_DEFUN(AC_CHECK_GNU_EXTENSIONS,
[
AC_MSG_CHECKING(if you need GNU extensions)
AC_CACHE_VAL(ac_cv_gnu_extensions,
[
cat > conftest.c << EOF
#include <features.h>

#ifdef __GNU_LIBRARY__
yes
#endif
EOF

if (eval "$ac_cpp conftest.c") 2>&5 |
  egrep "yes" >/dev/null 2>&1; then
  rm -rf conftest*
  ac_cv_gnu_extensions=yes
else
  ac_cv_gnu_extensions=no
fi
])

AC_MSG_RESULT($ac_cv_gnu_extensions)
if test "$ac_cv_gnu_extensions" = "yes"; then
  AC_DEFINE_UNQUOTED(_GNU_SOURCE)
fi
])


dnl Check for the type of the third argument of getsockname
AC_DEFUN(AC_CHECK_KSIZE_T,
[AC_MSG_CHECKING(for the third argument of getsockname)  
AC_LANG_CPLUSPLUS
AC_CACHE_VAL(ac_cv_ksize_t,
[AC_TRY_COMPILE([
#include <sys/types.h>
#include <sys/socket.h>
],[
socklen_t a=0; 
getsockname(0,(struct sockaddr*)0, &a);
],
ac_cv_ksize_t=socklen_t,
ac_cv_ksize_t=)
if test -z "$ac_cv_ksize_t"; then
ac_safe_cxxflags="$CXXFLAGS"
if test "$GCC" = "yes"; then
  CXXFLAGS="-Werror $CXXFLAGS"
fi
AC_TRY_COMPILE([
#include <sys/types.h>
#include <sys/socket.h>
],[
int a=0; 
getsockname(0,(struct sockaddr*)0, &a);
],
ac_cv_ksize_t=int,
ac_cv_ksize_t=size_t)
CXXFLAGS="$ac_safe_cxxflags"
fi
])

if test -z "$ac_cv_ksize_t"; then
  ac_cv_ksize_t=int
fi

AC_MSG_RESULT($ac_cv_ksize_t)
AC_DEFINE_UNQUOTED(ksize_t, $ac_cv_ksize_t)

])
dnl # ------------------------------------------------------------------------
dnl # chck for the pthreads library.
dnl # ------------------------------------------------------------------------

AC_DEFUN(AC_SS_CHECK_PTHREAD,
	[ 
		AC_ARG_WITH(pthread-check,[  --without-pthread-check Specifies to ignore the pthread library check ],SS_IGNORE_PTHREAD_CHECK="$withval",SS_IGNORE_PTHREAD_CHECK="NOTGIVEN")
		if test "$SS_IGNORE_PTHREAD_CHECK" = "NOTGIVEN"; then
			AC_MSG_CHECKING([for libpthread])
				AC_CACHE_VAL(ac_cv_lib_pthread,[
					ac_save_LIBS="$LIBS"
					LIBS="-lpthread"
					AC_TRY_LINK([
						#include <pthread.h>
						],
						[pthread_exit(0);],
						eval "ac_cv_lib_pthread=-lphtread",
						eval "ac_cv_lib_pthread=no"
					)
					LIBS="$ac_save_LIBS"
				])
				if eval "test ! \"`echo $ac_cv_lib_pthread`\" = no"; then
					AC_MSG_RESULT(Ok: seems to work...)
				else
					AC_MSG_RESULT([Not found...sorry : KVirc requires the pthread library.])
					AC_MSG_RESULT([Please check if it is correctly installed (in your usual library directory!).])
					AC_MSG_RESULT([If it is , please try running configure with the --without-pthread-check option.])
					AC_MSG_RESULT([If not , look for the pthread library package on your closer sunsite ftp mirror.])
					AC_MSG_ERROR([Aborting on the pthread library check.])
				fi
		else
			AC_MSG_RESULT(Trusting you...skipping the pthread library check)
		fi
	]
)

AC_DEFUN(AC_SS_CHECK_IF_PLUGIN_SUPPORT_IS_REQUESTED,
	[
 		AC_MSG_CHECKING(if plugin support is requested)
  		AC_ARG_WITH(plugin-support,[  --without-plugin-support Specifies to do not compile the plugin support ],SS_PLUGIN_REQUESTED="$withval",SS_PLUGIN_REQUESTED="yes")
		if test "$SS_PLUGIN_REQUESTED" = "yes"; then
			AC_MSG_RESULT(yes)
		else
		    SS_PLUGIN_REQUESTED="no"
		    AC_MSG_RESULT(no)
		fi
	]
)

AC_DEFUN(AC_SS_FIND_DL,
	[
		AC_SS_CHECK_IF_PLUGIN_SUPPORT_IS_REQUESTED
		if test "$SS_PLUGIN_REQUESTED" = "yes"; then
			AC_MSG_CHECKING([for libdl])
			AC_CACHE_VAL(ac_cv_lib_dl,[
				ac_save_LIBS="$LIBS"
				LIBS="-rdynamic -ldl"
				AC_TRY_LINK([ /*Override internal prototypes*/
					#include <dlfcn.h>
					],
					[dlopen("/usr/lib/libdl.so",RTLD_NOW);],
					eval "ac_cv_lib_dl=-ldl",
					eval "ac_cv_lib_dl=no"
				)
				LIBS="$ac_save_LIBS"
			])
			if eval "test ! \"`echo $ac_cv_lib_dl`\" = no"; then
				SS_HAVE_LIBDL="yes"
				AC_SUBST(SS_HAVE_LIBDL)
				AC_MSG_RESULT(Ok: seems to work...)
				AC_DEFINE_UNQUOTED(HAVE_LIBDL)
			else
				AC_MSG_RESULT(Not found , or -rdynamic does not work.)
			fi
		fi
	])
dnl # ------------------------------------------------------------------------
dnl # Find a file path(list of files,list of dirs,variable)
dnl # Searches for one of the files in the directories specified
dnl # Sets the veriable to "FAILED" or to the path where the file was found
dnl # ------------------------------------------------------------------------

AC_DEFUN(AC_SS_FIND_FILE_PATH,
	[
		$3="FAILED"
		for a_dir in $2; do
			for a_file in $1; do
				if test -r "$a_dir/$a_file"; then
					$3=$a_dir
					break 2
				fi
			done
		done	
	]
)

AC_DEFUN(AC_SS_FIND_FILE_PATH_EXT,
	[
		$4="FAILED"

		for a_dir in $2; do
			for a_semidir in $3; do
				for a_file in $1; do
					if test -r "$a_dir/$a_semidir/$a_file"; then
						$4="$a_dir/$a_semidir"
						break 3
					fi
				done
			done
		done
	]
)

AC_DEFUN(AC_SS_FIND_QT,
	[
		AC_SS_FIND_QT_GENERAL_DIR
		AC_SS_FIND_QT_LIBRARY_DIR
		AC_SS_FIND_QT_INCLUDE_DIR
		AC_SS_FIND_QT_MOC
		AC_SS_ENSURE_CAN_COMPILE_X_AND_QT
	]
)

AC_DEFUN(AC_SS_FIND_QT_GENERAL_DIR,
	[
		AC_MSG_CHECKING(for the general Qt directory)
		ss_qt_general_test_dirs="/usr /usr/local /usr /usr/local /usr/build /usr/X11R6 /usr/lib /usr/lib /usr/src /usr/lib /usr/local/lib /"
		if test -n "$HOME"; then
			ss_qt_general_test_dirs="$ss_qt_general_test_dirs $HOME $HOME/lib"
		fi
		if test -n "$QTDIR"; then
			ss_qt_general_test_dirs="$QTDIR $ss_qt_general_test_dirs"
		fi
		ss_qt_general_test_path_suffix=". qt qt2.00 qt2 qt.2 qt-2 qt-2.0 qt-2.00 qt-2.0.0 qt-2.0.1 qt-2.0.2 qt-2.0.3"

		AC_SS_FIND_FILE_PATH_EXT(include/qwindowsstyle.h,$ss_qt_general_test_dirs,$ss_qt_general_test_path_suffix,SS_QT_GENERAL_DIR)

		if test "$SS_QT_GENERAL_DIR" = "FAILED"; then
			AC_MSG_RESULT(failed...continuing with normal checks)
			unset SS_QT_GENERAL_DIR
		else
			AC_MSG_RESULT(Seems to be $SS_QT_GENERAL_DIR)
		fi
	]
)

AC_DEFUN(AC_SS_FIND_QT_INCLUDE_DIR,
	[
		AC_ARG_WITH(qt-include-dir,[  --with-qt-include-dir   path to the Qt headers ],SS_QT_INCLUDE_DIR="$withval",SS_QT_INCLUDE_DIR="NOTGIVEN")
		if test "$SS_QT_INCLUDE_DIR" = "NOTGIVEN"; then

			AC_MSG_CHECKING(for Qt header files)

			ss_qt_include_test_dirs="/include /usr/include /usr/local/include /usr/qt/include /usr/local/qt/include /usr/X11R6/include /usr/lib/qt/include /usr/lib/qt /usr/include/X11"
			test -n "$QTDIR" && ss_qt_include_test_dirs="$QTDIR/include $QTDIR $ss_qt_include_test_dirs"
			ss_qt_include_test_dirs="$ss_qt_include_test_dirs /usr/include/qt /usr/local/include/qt /include/qt /usr/X11R6/include/qt /usr/build/qt/include"
			ss_qt_include_test_dirs="$ss_qt_include_test_dirs /usr/include/qt2 /usr/local/include/qt2 /include/qt2 /usr/X11R6/include/qt2 /usr/include/X11/qt2"
			test -n "$SS_QT_GENERAL_DIR" && ss_qt_include_test_dirs="$SS_QT_GENERAL_DIR/include $ss_qt_include_test_dirs"

			AC_SS_FIND_FILE_PATH(qwindowsstyle.h,$ss_qt_include_test_dirs,SS_QT_INCLUDE_DIR)

			if test "$SS_QT_INCLUDE_DIR" = "FAILED"; then
				AC_MSG_RESULT("FAILED")
				AC_MSG_ERROR([
**************************************************************
The Qt include files can not be found.
Make sure that Qt is correctly installed on your system
and try passing the --with-qt-include-dir option to configure.
**************************************************************
				])
			else
				AC_MSG_RESULT(found in $SS_QT_INCLUDE_DIR)
				AC_SUBST(SS_QT_INCLUDE_DIR)
			fi

		else
			AC_MSG_RESULT(using user supplied path for the Qt include files $SS_QT_INCLUDE_DIR)
			AC_SUBST(SS_QT_INCLUDE_DIR)
		fi
	]
)

AC_DEFUN(AC_SS_FIND_QT_LIBRARY_DIR,
	[
		AC_ARG_WITH(qt-library-dir,[  --with-qt-library-dir   path to the Qt library ],SS_QT_LIBRARY_DIR="$withval",SS_QT_LIBRARY_DIR="NOTGIVEN")
		if test "$SS_QT_LIBRARY_DIR" = "NOTGIVEN"; then
			AC_MSG_CHECKING(for the Qt library)

			ss_qt_library_test_dirs="/lib /usr/lib /usr/local/lib /usr/qt/lib /usr/local/qt/lib /usr/X11R6/lib /usr/lib/qt/lib /usr/lib/qt /usr/local/lib/qt/lib"
			test -n "$QTDIR" && ss_qt_library_test_dirs="$QTDIR/lib $QTDIR $ss_qt_library_test_dirs"
			ss_qt_library_test_dirs="$ss_qt_library_test_dirs /usr/local/lib/qt /usr/X11R6/lib/qt /usr/build/qt/lib"
			if test -n "$SS_QT_GENERAL_DIR"; then
				ss_qt_library_test_dirs="$SS_QT_GENERAL_DIR/lib $ss_qt_library_test_dirs"
			fi

			AC_SS_FIND_FILE_PATH(libqt.so.2 libqt.so.2.0 libqt.a libqt.so,$ss_qt_library_test_dirs,SS_QT_LIBRARY_DIR)

			if test "$SS_QT_LIBRARY_DIR" = "FAILED"; then
				AC_MSG_RESULT("FAILED")
				AC_MSG_ERROR([
**************************************************************
The Qt library file can not be found.
Make sure that Qt is correctly installed on your system
and try passing the --with-qt-library-dir option to configure.
**************************************************************
				])
			else
				AC_MSG_RESULT(found in $SS_QT_LIBRARY_DIR)
				AC_SUBST(SS_QT_LIBRARY_DIR)
			fi
		else
			AC_MSG_RESULT(using user supplied path for the Qt library $SS_QT_LIBRARY_DIR)
			AC_SUBST(SS_QT_LIBRARY_DIR)
		fi
	]
)


AC_DEFUN(AC_SS_FIND_QT_MOC,
	[	
		AC_ARG_WITH(qt-moc,[  --with-qt-moc           filename of the Qt meta object compiler ],SS_QT_MOC="$withval",SS_QT_MOC="NOTGIVEN")
	 	if test "$SS_QT_MOC" = "NOTGIVEN"; then
	 		unset SS_QT_MOC
			if test -n "$SS_QT_GENERAL_DIR"; then
		 		AC_PATH_PROG(SS_QT_MOC,moc,"FAILED",$SS_QT_GENERAL_DIR/bin:$QTDIR/bin:$PATH:/usr/bin:/bin:/usr/local/bin:/usr/X11R6/bin:/usr/lib/qt/bin:/usr/local/qt/bin:/usr/X11R6/qt/bin:/usr/qt/bin:/usr/build/qt/bin)
			else
		 		AC_PATH_PROG(SS_QT_MOC,moc,"FAILED",$QTDIR/bin:$PATH:/usr/bin:/bin:/usr/local/bin:/usr/X11R6/bin:/usr/lib/qt/bin:/usr/local/qt/bin:/usr/X11R6/qt/bin:/usr/qt/bin:/usr/build/qt/bin)
			fi

			if test "$SS_QT_MOC" = "FAILED"; then
				AC_MSG_ERROR([The Qt meta object compiler can not be found.Make sure that it is installed on your system and try passing the --with-qt-moc argument to configure])
			fi
		else
			AC_MSG_RESULT(using user supplied path for moc $SS_QT_MOC)
			AC_SUBST(SS_QT_MOC)
	 	fi
	]
)


AC_DEFUN(AC_SS_ENSURE_CAN_COMPILE_X_AND_QT,
	[
		AC_ARG_WITH(qt-check,[  --without-qt-check      Do not check if Qt and X compile ],SS_CHECK_QTX_COMPILE="$withval",SS_CHECK_QTX_COMPILE="yes")
  		if test "$SS_CHECK_QTX_COMPILE" = "yes"; then
			AC_MSG_CHECKING(if we can compile an X-Qt application)
			AC_LANG_CPLUSPLUS
			ss_save_CPPFLAGS="$CPPFLAGS"
			ss_save_CXXFLAGS="$CXXFLAGS"
			ss_save_LDFLAGS="$LDFLAGS"
			ss_save_LIBS="$LIBS"
			CPPFLAGS="-I$SS_X_INCLUDE_DIR -I$SS_QT_INCLUDE_DIR $CPPFLAGS $X_CFLAGS"
			CXXFLAGS="-O2 -Wall -g $CXXFLAGS"
			LIBS="-L$SS_X_LIBRARY_DIR -L$SS_QT_LIBRARY_DIR $X_ $X_EXTRA_LIBS $X_LIBS $LIBS -lqt -lXext -lX11"
			LDFLAGS="-s $LDFLAGS"
			AC_TRY_LINK([#include "qwindowsstyle.h"],[ QWindowsStyle s; s.polish((QWidget *)0);],SS_QTX_LINKED_OK="TRUE",SS_QTX_LINKED_OK="FALSE")
			if test "$SS_QTX_LINKED_OK" = "FALSE"; then
				AC_MSG_ERROR([Failed to compile the Qt-X library test program])
			fi
			LIBS="$ss_save_LIBS"
			LDFLAGS="$ss_save_LDFLAGS"
			CXXFLAGS="$ss_save_CXXFLAGS"
			CPPFLAGS="$ss_save_CPPFLAGS"
			AC_MSG_RESULT(success)
		fi
	]
)
dnl #-------------------------------------------------------------------------
dnl # Find the X libraries and includes
dnl # sets:SS_X_INCLUDE_DIR, SS_X_LIBRARY_DIR
dns # sets:SS_X_EXTRA_GCC_FLAGS, SS_X_EXTRA_LDD_FLAGS
dnl #-------------------------------------------------------------------------

AC_DEFUN(AC_SS_FIND_X,
	[
		AC_PATH_XTRA
		if test -n "$no_x"; then
			AC_MSG_ERROR([Can not find the X libraries. Bad luck man...try passing one of the --x options to configure])
		else
 			SS_X_INCLUDE_DIR="$x_includes"
			SS_X_LIBRARY_DIR="$x_libraries"
			
			SS_X_EXTRA_LDD_FLAGS="$X_EXTRA_LIBS"
			for a_flag in "$X_LIBS"; do
				if test $a_flag != "-L$x_libraries"; then
					SS_X_EXTRA_LDD_FLAGS="$SS_X_EXTRA_LDD_FLAGS $a_flag"
				fi
			done
			
			SS_X_EXTRA_GCC_FLAGS=""
			for a_flag in "$X_CFLAGS"; do
				if test $a_flag != "-I$x_includes"; then
					SS_X_EXTRA_GCC_FLAGS="$SS_X_EXTRA_GCC_FLAGS $a_flag"
				fi
			done	
			
			AC_SUBST(SS_X_INCLUDE_DIR)
			AC_SUBST(SS_X_LIBRARY_DIR)
			AC_SUBST(SS_X_EXTRA_GCC_FLAGS)
			AC_SUBST(SS_X_EXTRA_LDD_FLAGS)
		fi
	]
)## ------------------------------------------------------------------------

AC_DEFUN(AC_SS_CHECK_IF_JPEG_SUPPORT_IS_REQUESTED,
	[
 		AC_MSG_CHECKING(if Jpeg support is requested)
  		AC_ARG_WITH(jpeg-support,[  --without-jpeg-support  Specifies to do not compile the jpeg support ],SS_JPEG_REQUESTED="$withval",SS_JPEG_REQUESTED="yes")
		if test "$SS_JPEG_REQUESTED" = "yes"; then
			AC_MSG_RESULT(yes)
		else
		    SS_JPEG_REQUESTED="no"
		    AC_MSG_RESULT(no)
		fi
	]
)

AC_DEFUN(AC_SS_FIND_JPEG,
	[
		AC_SS_CHECK_IF_JPEG_SUPPORT_IS_REQUESTED
		if test "$SS_JPEG_REQUESTED" = "yes"; then
			AC_MSG_CHECKING([for jpeglib])
			AC_CACHE_VAL(ac_cv_lib_jpeg,[
				ac_save_LIBS="$LIBS"
				LIBS="-ljpeg"
				AC_TRY_LINK([ /*Override internal prototypes*/
					struct jpeg_decompress_struct;
					typedef struct jpeg_decompress_struct * j_decompress_ptr;
					typedef int size_t;
					#ifdef __cplusplus
					extern "C" {
					#endif
						void jpeg_CreateDecompress(j_decompress_ptr cinfo,int version,size_t struct_size);
					#ifdef __cplusplus
					}
					#endif
					],
					[jpeg_CreateDecompress(0,0,0);],
					eval "ac_cv_lib_jpeg=-ljpeg",
					eval "ac_cv_lib_jpeg=no"
				)
				LIBS="$ac_save_LIBS"
			])
			if eval "test ! \"`echo $ac_cv_lib_jpeg`\" = no"; then
				SS_HAVE_LIBJPEG="yes"
				AC_SUBST(SS_HAVE_LIBJPEG)
				AC_MSG_RESULT(Ok: seems to work...)
				AC_DEFINE_UNQUOTED(HAVE_LIBJPEG)
			else
				AC_MSG_RESULT(Not found...)
			fi
		fi
	])

# serial 24 AM_PROG_LIBTOOL
AC_DEFUN(AM_PROG_LIBTOOL,
[AC_REQUIRE([AM_ENABLE_SHARED])dnl
AC_REQUIRE([AM_ENABLE_STATIC])dnl
AC_REQUIRE([AC_CANONICAL_HOST])dnl
AC_REQUIRE([AC_PROG_RANLIB])dnl
AC_REQUIRE([AC_PROG_CC])dnl
AC_REQUIRE([AM_PROG_LD])dnl
AC_REQUIRE([AM_PROG_NM])dnl
AC_REQUIRE([AC_PROG_LN_S])dnl
dnl
# Always use our own libtool.
LIBTOOL='$(SHELL) $(top_builddir)/libtool'
AC_SUBST(LIBTOOL)dnl

# Check for any special flags to pass to ltconfig.
libtool_flags=
test "$enable_shared" = no && libtool_flags="$libtool_flags --disable-shared"
test "$enable_static" = no && libtool_flags="$libtool_flags --disable-static"
test "$silent" = yes && libtool_flags="$libtool_flags --silent"
test "$ac_cv_prog_gcc" = yes && libtool_flags="$libtool_flags --with-gcc"
test "$ac_cv_prog_gnu_ld" = yes && libtool_flags="$libtool_flags --with-gnu-ld"

# Some flags need to be propagated to the compiler or linker for good
# libtool support.
case "$host" in
*-*-irix6*)
  # Find out which ABI we are using.
  echo '[#]line __oline__ "configure"' > conftest.$ac_ext
  if AC_TRY_EVAL(ac_compile); then
    case "`/usr/bin/file conftest.o`" in
    *32-bit*)
      LD="${LD-ld} -32"
      ;;
    *N32*)
      LD="${LD-ld} -n32"
      ;;
    *64-bit*)
      LD="${LD-ld} -64"
      ;;
    esac
  fi
  rm -rf conftest*
  ;;

*-*-sco3.2v5*)
  # On SCO OpenServer 5, we need -belf to get full-featured binaries.
  CFLAGS="$CFLAGS -belf"
  ;;
esac

# Actually configure libtool.  ac_aux_dir is where install-sh is found.
CC="$CC" CFLAGS="$CFLAGS" CPPFLAGS="$CPPFLAGS" \
LD="$LD" NM="$NM" RANLIB="$RANLIB" LN_S="$LN_S" \
${CONFIG_SHELL-/bin/sh} $ac_aux_dir/ltconfig \
$libtool_flags --no-verify $ac_aux_dir/ltmain.sh $host \
|| AC_MSG_ERROR([libtool configure failed])
])

# AM_ENABLE_SHARED - implement the --enable-shared flag
# Usage: AM_ENABLE_SHARED[(DEFAULT)]
#   Where DEFAULT is either `yes' or `no'.  If omitted, it defaults to
#   `yes'.
AC_DEFUN(AM_ENABLE_SHARED_EX,
[define([AM_ENABLE_SHARED_DEFAULT], ifelse($1, no, no, yes))dnl
AC_PROVIDE(AM_ENABLE_SHARED)
AC_ARG_ENABLE(shared,
changequote(<<, >>)dnl
<<  --enable-shared         build shared libraries [default=>>AM_ENABLE_SHARED_DEFAULT]
changequote([, ])dnl
[  --enable-shared=PKGS    only build shared libraries if the current package
                          appears as an element in the PKGS list],
[p=${PACKAGE-default}
case "$enableval" in
yes) enable_shared=yes ;;
no) enable_shared=no ;;
*)
  enable_shared=no
  # Look at the argument we got.  We use all the common list separators.
  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:,"
  for pkg in $enableval; do
    if test "X$pkg" = "X$p"; then
      enable_shared=yes
    fi
  done
  IFS="$ac_save_ifs"
  ;;
esac],
enable_shared=AM_ENABLE_SHARED_DEFAULT)dnl
])

AC_DEFUN(AM_ENABLE_SHARED,
[define([AM_ENABLE_SHARED_DEFAULT], ifelse($1, no, no, yes))dnl
AC_ARG_ENABLE(shared,
changequote(<<, >>)dnl
<<  --enable-shared         build shared libraries [default=>>AM_ENABLE_SHARED_DEFAULT],
changequote([, ])dnl
[
if test "$enableval" = no; then
  enable_shared=no
else
  enable_shared=yes
fi
],
enable_shared=AM_ENABLE_SHARED_DEFAULT)dnl
])


# AM_DISABLE_SHARED - set the default shared flag to --disable-shared
AC_DEFUN(AM_DISABLE_SHARED,
[AM_ENABLE_SHARED(no)])

# AM_DISABLE_STATIC - set the default static flag to --disable-static
AC_DEFUN(AM_DISABLE_STATIC,
[AM_ENABLE_STATIC(no)])

# AM_ENABLE_STATIC - implement the --enable-static flag
# Usage: AM_ENABLE_STATIC[(DEFAULT)]
#   Where DEFAULT is either `yes' or `no'.  If omitted, it defaults to
#   `yes'.
AC_DEFUN(AM_ENABLE_STATIC_EX,
[define([AM_ENABLE_STATIC_DEFAULT], ifelse($1, no, no, yes))dnl
AC_PROVIDE(AM_ENABLE_STATIC)
AC_ARG_ENABLE(static,
changequote(<<, >>)dnl
<<  --enable-static         build static libraries [default=>>AM_ENABLE_STATIC_DEFAULT]
changequote([, ])dnl
[  --enable-static=PKGS    only build shared libraries if the current package
                          appears as an element in the PKGS list],
[p=${PACKAGE-default}
case "$enableval" in
yes) enable_static=yes ;;
no) enable_static=no ;;
*)
  enable_static=no
  # Look at the argument we got.  We use all the common list separators.
  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:,"
  for pkg in $enableval; do
    if test "X$pkg" = "X$p"; then
      enable_static=yes
    fi
  done
  IFS="$ac_save_ifs"
  ;;
esac],
enable_static=AM_ENABLE_STATIC_DEFAULT)dnl
])

AC_DEFUN(AM_ENABLE_STATIC,
[define([AM_ENABLE_STATIC_DEFAULT], ifelse($1, no, no, yes))dnl
AC_ARG_ENABLE(static,
changequote(<<, >>)dnl
<<  --enable-static         build static libraries [default=>>AM_ENABLE_STATIC_DEFAULT],
changequote([, ])dnl
[if test "$enableval" = no; then
  enable_static=no
else
  enable_static=yes
fi],
enable_static=AM_ENABLE_STATIC_DEFAULT)dnl
])

AC_DEFUN(AM_DISABLE_LIBRARIES,
[
AC_PROVIDE([AM_ENABLE_STATIC])
AC_PROVIDE([AM_ENABLE_SHARED])
enable_static=no
enable_shared=no
])

# AM_PROG_LD - find the path to the GNU or non-GNU linker
AC_DEFUN(AM_PROG_LD,
[AC_ARG_WITH(gnu-ld,
[  --with-gnu-ld           assume the C compiler uses GNU ld [default=no]],
test "$withval" = no || with_gnu_ld=yes, with_gnu_ld=no)
AC_REQUIRE([AC_PROG_CC])
ac_prog=ld
if test "$ac_cv_prog_gcc" = yes; then
  # Check if gcc -print-prog-name=ld gives a path.
  AC_MSG_CHECKING([for ld used by GCC])
  ac_prog=`($CC -print-prog-name=ld) 2>&5`
  case "$ac_prog" in
  # Accept absolute paths.
  /* | [A-Za-z]:\\*)
    test -z "$LD" && LD="$ac_prog"
    ;;
  "")
    # If it fails, then pretend we aren't using GCC.
    ac_prog=ld
    ;;
  *)
    # If it is relative, then search for the first ld in PATH.
    with_gnu_ld=unknown
    ;;
  esac
elif test "$with_gnu_ld" = yes; then
  AC_MSG_CHECKING([for GNU ld])
else
  AC_MSG_CHECKING([for non-GNU ld])
fi
AC_CACHE_VAL(ac_cv_path_LD,
[if test -z "$LD"; then
  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
  for ac_dir in $PATH; do
    test -z "$ac_dir" && ac_dir=.
    if test -f "$ac_dir/$ac_prog"; then
      ac_cv_path_LD="$ac_dir/$ac_prog"
      # Check to see if the program is GNU ld.  I'd rather use --version,
      # but apparently some GNU ld's only accept -v.
      # Break only if it was the GNU/non-GNU ld that we prefer.
      if "$ac_cv_path_LD" -v 2>&1 < /dev/null | egrep '(GNU|with BFD)' > /dev/null; then
	test "$with_gnu_ld" != no && break
      else
        test "$with_gnu_ld" != yes && break
      fi
    fi
  done
  IFS="$ac_save_ifs"
else
  ac_cv_path_LD="$LD" # Let the user override the test with a path.
fi])
LD="$ac_cv_path_LD"
if test -n "$LD"; then
  AC_MSG_RESULT($LD)
else
  AC_MSG_RESULT(no)
fi
test -z "$LD" && AC_MSG_ERROR([no acceptable ld found in \$PATH])
AC_SUBST(LD)
AM_PROG_LD_GNU
])

AC_DEFUN(AM_PROG_LD_GNU,
[AC_CACHE_CHECK([if the linker ($LD) is GNU ld], ac_cv_prog_gnu_ld,
[# I'd rather use --version here, but apparently some GNU ld's only accept -v.
if $LD -v 2>&1 </dev/null | egrep '(GNU|with BFD)' 1>&5; then
  ac_cv_prog_gnu_ld=yes
else
  ac_cv_prog_gnu_ld=no
fi])
])

# AM_PROG_NM - find the path to a BSD-compatible name lister
AC_DEFUN(AM_PROG_NM,
[AC_MSG_CHECKING([for BSD-compatible nm])
AC_CACHE_VAL(ac_cv_path_NM,
[case "$NM" in
/* | [A-Za-z]:\\*)
  ac_cv_path_NM="$NM" # Let the user override the test with a path.
  ;;
*)
  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
  for ac_dir in /usr/ucb /usr/ccs/bin $PATH /bin; do
    test -z "$ac_dir" && ac_dir=.
    if test -f $ac_dir/nm; then
      # Check to see if the nm accepts a BSD-compat flag.
      # Adding the `sed 1q' prevents false positives on HP-UX, which says:
      #   nm: unknown option "B" ignored
      if ($ac_dir/nm -B /dev/null 2>&1 | sed '1q'; exit 0) | egrep /dev/null >/dev/null; then
        ac_cv_path_NM="$ac_dir/nm -B"
      elif ($ac_dir/nm -p /dev/null 2>&1 | sed '1q'; exit 0) | egrep /dev/null >/dev/null; then
        ac_cv_path_NM="$ac_dir/nm -p"
      else
        ac_cv_path_NM="$ac_dir/nm"
      fi
      break
    fi
  done
  IFS="$ac_save_ifs"
  test -z "$ac_cv_path_NM" && ac_cv_path_NM=nm
  ;;
esac])
NM="$ac_cv_path_NM"
AC_MSG_RESULT([$NM])
AC_SUBST(NM)
])
dnl Check if localisation support has to be compiled and installed

AC_DEFUN(AC_SS_CHECK_LOCALIZE,
	[
		AC_MSG_CHECKING(if locale support is requested)
  		AC_ARG_WITH(locale,[  --without-locale        Specifies to do not support localization ],SS_LOCALE_REQUESTED="$withval",SS_LOCALE_REQUESTED="yes")
		if test "$SS_LOCALE_REQUESTED" = "yes"; then
			AC_MSG_RESULT(yes)
		else
		    SS_LOCALE_REQUESTED="no"
		    AC_MSG_RESULT(no)
		fi

		if test "$SS_LOCALE_REQUESTED" = "yes"; then
			AC_PATH_PROG(SS_MSGFMT,msgfmt,":",$PATH:/bin:/usr/bin:/bin:/usr/local/bin:/usr/X11R6/bin:/usr/lib/qt/bin:/usr/local/qt/bin:/usr/X11R6/qt/bin:/usr/qt/bin:/usr/build/qt/bin)
			if test "SS_MSGFMT" != ":"; then
				AC_DEFINE(COMPILE_NEED_LOCALE)
			fi
 		else
			SS_MSGFMT=":"
		fi

		AC_SUBST(SS_MSGFMT)
	]
)

# Do all the work for Automake.  This macro actually does too much --
# some checks are only needed if your package does certain things.
# But this isn't really a big deal.

# serial 1

dnl Usage:
dnl AM_INIT_AUTOMAKE(package,version, [no-define])

AC_DEFUN(AM_INIT_AUTOMAKE,
[AC_REQUIRE([AC_PROG_INSTALL])
dnl We require 2.13 because we rely on SHELL being computed by configure.
AC_PREREQ([2.13])
PACKAGE=[$1]
AC_SUBST(PACKAGE)
VERSION=[$2]
AC_SUBST(VERSION)
dnl test to see if srcdir already configured
if test "`cd $srcdir && pwd`" != "`pwd`" && test -f $srcdir/config.status; then
  AC_MSG_ERROR([source directory already configured; run "make distclean" there first])
fi
ifelse([$3],,
AC_DEFINE_UNQUOTED(PACKAGE, "$PACKAGE", [Name of package])
AC_DEFINE_UNQUOTED(VERSION, "$VERSION", [Version number of package]))
AC_REQUIRE([AM_SANITY_CHECK])
AC_REQUIRE([AC_ARG_PROGRAM])
dnl FIXME This is truly gross.
missing_dir=`cd $ac_aux_dir && pwd`
AM_MISSING_PROG(ACLOCAL, aclocal, $missing_dir)
AM_MISSING_PROG(AUTOCONF, autoconf, $missing_dir)
AM_MISSING_PROG(AUTOMAKE, automake, $missing_dir)
AM_MISSING_PROG(AUTOHEADER, autoheader, $missing_dir)
AM_MISSING_PROG(MAKEINFO, makeinfo, $missing_dir)
AC_REQUIRE([AC_PROG_MAKE_SET])])

#
# Check to make sure that the build environment is sane.
#

AC_DEFUN(AM_SANITY_CHECK,
[AC_MSG_CHECKING([whether build environment is sane])
# Just in case
sleep 1
echo timestamp > conftestfile
# Do `set' in a subshell so we don't clobber the current shell's
# arguments.  Must try -L first in case configure is actually a
# symlink; some systems play weird games with the mod time of symlinks
# (eg FreeBSD returns the mod time of the symlink's containing
# directory).
if (
   set X `ls -Lt $srcdir/configure conftestfile 2> /dev/null`
   if test "[$]*" = "X"; then
      # -L didn't work.
      set X `ls -t $srcdir/configure conftestfile`
   fi
   if test "[$]*" != "X $srcdir/configure conftestfile" \
      && test "[$]*" != "X conftestfile $srcdir/configure"; then

      # If neither matched, then we have a broken ls.  This can happen
      # if, for instance, CONFIG_SHELL is bash and it inherits a
      # broken ls alias from the environment.  This has actually
      # happened.  Such a system could not be considered "sane".
      AC_MSG_ERROR([ls -t appears to fail.  Make sure there is not a broken
alias in your environment])
   fi

   test "[$]2" = conftestfile
   )
then
   # Ok.
   :
else
   AC_MSG_ERROR([newly created file is older than distributed files!
Check your system clock])
fi
rm -f conftest*
AC_MSG_RESULT(yes)])

dnl AM_MISSING_PROG(NAME, PROGRAM, DIRECTORY)
dnl The program must properly implement --version.
AC_DEFUN(AM_MISSING_PROG,
[AC_MSG_CHECKING(for working $2)
# Run test in a subshell; some versions of sh will print an error if
# an executable is not found, even if stderr is redirected.
# Redirect stdin to placate older versions of autoconf.  Sigh.
if ($2 --version) < /dev/null > /dev/null 2>&1; then
   $1=$2
   AC_MSG_RESULT(found)
else
   $1="$3/missing $2"
   AC_MSG_RESULT(missing)
fi
AC_SUBST($1)])

# Like AC_CONFIG_HEADER, but automatically create stamp file.

AC_DEFUN(AM_CONFIG_HEADER,
[AC_PREREQ([2.12])
AC_CONFIG_HEADER([$1])
dnl When config.status generates a header, we must update the stamp-h file.
dnl This file resides in the same directory as the config header
dnl that is generated.  We must strip everything past the first ":",
dnl and everything past the last "/".
AC_OUTPUT_COMMANDS(changequote(<<,>>)dnl
ifelse(patsubst(<<$1>>, <<[^ ]>>, <<>>), <<>>,
<<test -z "<<$>>CONFIG_HEADERS" || echo timestamp > patsubst(<<$1>>, <<^\([^:]*/\)?.*>>, <<\1>>)stamp-h<<>>dnl>>,
<<am_indx=1
for am_file in <<$1>>; do
  case " <<$>>CONFIG_HEADERS " in
  *" <<$>>am_file "*<<)>>
    echo timestamp > `echo <<$>>am_file | sed -e 's%:.*%%' -e 's%[^/]*$%%'`stamp-h$am_indx
    ;;
  esac
  am_indx=`expr "<<$>>am_indx" + 1`
done<<>>dnl>>)
changequote([,]))])

