#!/bin/bash

# First get the list of all the files containing @document
FILE_NAMES_KVIRC=`find ../../src/kvirc/*.cpp`
FILE_NAMES_CORE=`find ../../src/kvicore/*.cpp`
FILE_NAMES_LIBRARY=`find ../../src/kvilib/*.cpp`
FILE_NAMES_PLUGINS=`find ../../src/plugins/*/*.cpp`

FILE_NAMES="$FILE_NAMES_KVIRC $FILE_NAMES_CORE $FILE_NAMES_LIBRARY $FILE_NAMES_PLUGINS"

DOC_LINKS=""

for a_file in $FILE_NAMES; do
	DOC_NAMES=`grep -h -i "@document:" $a_file | sed -e 's/[	 ]*@document:[ ]*//g'`	
	if test -n "$DOC_NAMES"; then
		for a_name in $DOC_NAMES; do
			LOWER_NAME=`echo "$a_name" | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
			echo "Generating ../../data/help/misc/$LOWER_NAME"
			DOCUMENT_DATA=`grep -h -i -A 150 "@document:[ ]*$a_name" $a_file`
			# Now strip the first line and the lines after the end of the comment
			DOCUMENT_DATA=`echo "$DOCUMENT_DATA" | sed -e '/@document:[ ]*[a-zA-Z_]*/ d'`
			DOCUMENT_DATA=`echo "$DOCUMENT_DATA" | sed -e '/\*\// q'`
			DOCUMENT_DATA=`echo "$DOCUMENT_DATA" | sed -e '/\*\// d'`	
			# Strip empty lines and kill leading tabs
			DOCUMENT_DATA=`echo "$DOCUMENT_DATA" | grep -h "[a-zA-Z0-9{}]"`
		 	DOCUMENT_DATA=`echo "$DOCUMENT_DATA" | sed -e 's/^[	 ]*//'`
		 	DOCUMENT_TITLE=`echo "$DOCUMENT_DATA" | grep -i "@title:"`
		 	DOCUMENT_TITLE=`echo "$DOCUMENT_TITLE" | sed -e 's/[	 ]*@title:[ ]*//g'`
			DOCUMENT_DATA=`echo "$DOCUMENT_DATA" | sed -e '/@title:[ ]*[a-zA-Z_ ]*/ d'`
		 	# Create the main document
		 	DOCUMENT="<doctitle>$DOCUMENT_TITLE</doctitle>
<docbody>
<hr>
$DOCUMENT_DATA
<hr>
<a href=\"index.kvihelp\">Main index</a> <a href=\"misc.kvihelp\">Misc documentation index</a>
</docbody>
"
			echo "$DOCUMENT" > ../../data/help/misc/$LOWER_NAME

			if test -n "$DOC_LINKS"; then
				DOC_LINKS="$DOC_LINKS<br>
<a href=\"$LOWER_NAME\">$DOCUMENT_TITLE</a>"
			else
				DOC_LINKS="<a href=\"$LOWER_NAME\">$DOCUMENT_TITLE</a>"
			fi

		done
	fi
done

echo "Generating ../../data/help/misc/misc.kvihelp"

DOCUMENT="<doctitle>Misc documentation index index</doctitle>
<docbody>
<hr>
$DOC_LINKS<br>
<hr>
<a href=\"index.kvihelp\">Main index</a>
</docbody>"

echo "$DOCUMENT" > ../../data/help/misc/misc.kvihelp

# Now regenerate the Makefile.am

LS_OUTPUT=`ls ../../data/help/misc/*.kvihelp | sed -e 's/^..\/..\/data\/help\/misc\///'`

FILES_OUTPUT=""
for a_file in $LS_OUTPUT; do
	if test -n "$FILES_OUTPUT"; then
		FILES_OUTPUT="$FILES_OUTPUT \\
			$a_file"
	else
		FILES_OUTPUT="$a_file"
	fi
done

MAKEFILE_TEXT="datadir= \$(helpdir)
data_DATA= $FILES_OUTPUT
EXTRA_DIST= \$(data_DATA)
"

echo "Generating ../../data/help/misc/Makefile.am"
echo "$MAKEFILE_TEXT" > ../../data/help/misc/Makefile.am
