#!/bin/bash

# First get the list of all the files containing @quickhelp
FILE_NAMES=`find ../../src/kvirc/*.cpp`

QH_LINKS=""

for a_file in $FILE_NAMES; do
	QH_NAMES=`grep -h -i "@quickhelp:" $a_file | sed -e 's/[	 ]*@quickhelp:[ ]*//g'`	
	if test -n "$QH_NAMES"; then
		for a_name in $QH_NAMES; do
			LOWER_NAME=`echo "$a_name" | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
			echo "Generating ../../data/help/quickhelp/qh_$LOWER_NAME.kvihelp"
			DOCUMENT_DATA=`grep -h -i -A 150 "@quickhelp:[ ]*$a_name" $a_file`
			# Now strip the first line and the lines after the end of the comment
			DOCUMENT_DATA=`echo "$DOCUMENT_DATA" | sed -e '/@quickhelp:[ ]*[a-zA-Z_]*/ d'`
			DOCUMENT_DATA=`echo "$DOCUMENT_DATA" | sed -e '/\*\// q'`
			DOCUMENT_DATA=`echo "$DOCUMENT_DATA" | sed -e '/\*\// d'`	
			# Strip empty lines and kill leading tabs
			DOCUMENT_DATA=`echo "$DOCUMENT_DATA" | grep -h "[a-zA-Z0-9{}]"`
		 	DOCUMENT_DATA=`echo "$DOCUMENT_DATA" | sed -e 's/^[	 ]*//'`
		 	WIDGET_NAME=`echo "$DOCUMENT_DATA" | grep -i "@widget:"`
		 	WIDGET_NAME=`echo "$WIDGET_NAME" | sed -e 's/[	 ]*@widget:[ ]*//g'`
			DOCUMENT_DATA=`echo "$DOCUMENT_DATA" | sed -e '/@widget:[ ]*[a-zA-Z_ ]*/ d'`
		 	# Create the main document
		 	DOCUMENT="<doctitle>$WIDGET_NAME</doctitle>
<docbody>
<hr>
$DOCUMENT_DATA
<hr>
<a href=\"index.kvihelp\">Main index</a> <a href=\"quickhelp.kvihelp\">Widget index</a>
</docbody>
"
			echo "$DOCUMENT" > ../../data/help/quickhelp/qh_$LOWER_NAME.kvihelp

			if test -n "$QH_LINKS"; then
				QH_LINKS="$QH_LINKS<br>
<a href=\"qh_$LOWER_NAME.kvihelp\">$WIDGET_NAME</a>"
			else
				QH_LINKS="<a href=\"qh_$LOWER_NAME.kvihelp\">$WIDGET_NAME</a>"
			fi

		done
	fi
done

echo "Generating ../../data/help/quickhelp/quickhelp.kvihelp"

DOCUMENT="<doctitle>Widget index</doctitle>
<docbody>
<hr>
$QH_LINKS<br>
<hr>
<a href=\"index.kvihelp\">Main index</a>
</docbody>"

echo "$DOCUMENT" > ../../data/help/quickhelp/quickhelp.kvihelp

# Now regenerate the Makefile.am

LS_OUTPUT=`ls ../../data/help/quickhelp/*.kvihelp | sed -e 's/^..\/..\/data\/help\/quickhelp\///'`

FILES_OUTPUT=""
for a_file in $LS_OUTPUT; do
	if test -n "$FILES_OUTPUT"; then
		FILES_OUTPUT="$FILES_OUTPUT \\
			$a_file"
	else
		FILES_OUTPUT="$a_file"
	fi
done

MAKEFILE_TEXT="datadir= \$(helpdir)
data_DATA= $FILES_OUTPUT
EXTRA_DIST= \$(data_DATA)
"

echo "Generating ../../data/help/quickhelp/Makefile.am"
echo "$MAKEFILE_TEXT" > ../../data/help/quickhelp/Makefile.am
