#ifndef _KVI_HOF_H_INCLUDED_
#define _KVI_HOF_H_INCLUDED_

//
//   File : kvi_hof.h (/usr/build/NEW_kvirc/kvirc/src/kvirc/kvi_hof.h)
//   Last major modification : Sat Apr 3 1999 17:17:46 by Szymon Stefanek
//
//   This file is part of the KVirc irc client distribution
//   Copyright (C) 1998-1999 Szymon Stefanek (stefanek@tin.it)
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

#include "kvi_window.h"
#include "kvi_ircuser.h"
#include "kvi_string.h"

#include <qsplitter.h>
#include <qlabel.h>

class KviHallOfFame : public KviWindow
{
	Q_OBJECT
public:		// Consruction & Destruction
	KviHallOfFame(KviFrame *lpFrm,const char *name);
	~KviHallOfFame();
public:		// Fields
	QSplitter  *m_pTopSplitter;
	QSplitter  *m_pSplitter;
	QLabel *m_pTopicLabel;
	QLabel *m_pModeLabel;
	QLabel *m_pUsersLabel;
	KviStr  m_szLocalNick;
	KviStr  m_szLocalMask;
public:		// Methods
	virtual void setProperties(KviWindowProperty *p);
	virtual void saveProperties();
	void handleUserText(const KviStr &str);
protected:	// Protected methods
	virtual QPixmap * myIconPtr();
	virtual void applyOptions();
	void applyLabelsOptions();
	virtual void resizeEvent(QResizeEvent *);

	void startTheShow();
	void join(int idx,bool bPragma);
protected slots:
	void randomJoin();
	void randomPart();
	void massOp();
	void viewRightClicked(KviIrcView *);
	void listBoxRightClicked();
};

#endif //!_KVI_HOF_H_INCLUDED_
