//
//   File : kvidccchat.cpp (/usr/build/NEW_kvirc/kvirc/src/kvidccchat/kvidccchat.cpp)
//   Last major modification : Mon Apr 26 1999 23:27:32 by Szymon Stefanek
//
//   This file is part of the KVirc irc client distribution
//   Copyright (C) 1998-1999 Szymon Stefanek (stefanek@tin.it)
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

#include "../common/kvi_settings.h"

#include "kvi_dcc_slave.h"
#include "kvi_dcc_error.h"

#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <netinet/in.h>
#include <unistd.h>

//
// kvidccchat listen
// kvidccchat connect <host> <port>
//

void cleanup()
{
}

void fatal(int error)
{
	fprintf(stderr,"ERR:%d\n",error);
	cleanup();
	exit(-1);
}

void mainLoop(int sock,char *host,unsigned int port)
{
	// This is the main loop for the connection
	fprintf(stderr,"CNN:%s:%u\n",host,port);
//	for(;;){
//		
//	}
}

void listenMode()
{
	int listeningSock = -1;
	int sock = -1;
	unsigned int uPort;
	int err = kvi_dcc_listen(&listeningSock,&uPort);
	if(err != KVI_DCC_ERROR_Success)fatal(err);
	fprintf(stderr,"LST:%u\n",uPort);
	char ipBuffer[256]; //No overflow plz...(impossible)
	err = kvi_dcc_waitForAccept(listeningSock,&sock,&uPort,ipBuffer);
	close(listeningSock);
	if(err != KVI_DCC_ERROR_Success)fatal(err);
	mainLoop(sock,ipBuffer,uPort);
}

void connectMode(char *host,char *port)
{
	struct in_addr address;
	unsigned int uPort;
	//resolve the host
	int err = kvi_dcc_resolveHost(host,&address);
	if(err != KVI_DCC_ERROR_Success)fatal(err);
	if(sscanf(port,"%u",&uPort) !=1)fatal(KVI_DCC_ERROR_InvalidArgument);

	int sock = -1;
	err = kvi_dcc_connect(address,uPort,&sock);
	if(err != KVI_DCC_ERROR_Success)fatal(err);
	err = kvi_dcc_waitForConnection(sock);
	if(err != KVI_DCC_ERROR_Success){
		close(sock);
		fatal(err);
	}
	mainLoop(sock,host,uPort);
}

int main(int argc,char ** argv)
{
	struct in_addr hostAddress;

	// Check the arguments
	if(argc < 2)fatal(KVI_DCC_ERROR_MissingArgument);
	if(strcasecmp(argv[1],"listen") == 0)listenMode();
	else if(strcasecmp(argv[1],"connect") == 0){
		if(argc < 4)fatal(KVI_DCC_ERROR_MissingArgument);
		connectMode(argv[2],argv[3]);
	} else fatal(KVI_DCC_ERROR_InvalidArgument);
}
