#ifndef _KVI_COLORDIALOG_H_INCLUDED_
#define _KVI_COLORDIALOG_H_INCLUDED_

//
//   File : kvi_colordialog.h (/usr/build/NEW_kvirc/kvirc/src/kvilib/kvi_colordialog.h)
//   Last major modification : Sun Mar 21 1999 19:19:35 by Szymon Stefanek
//
//   This file is part of the KVirc irc client distribution
//   Copyright (C) 1999-2000 Szymon Stefanek (stefanek@tin.it)
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
#include <qdialog.h>
#include <qcolor.h>
#include <qframe.h>
#include <qimage.h>
#include <qlabel.h>

class KviBaseColorSelector : public QFrame
{
	Q_OBJECT
public:
	KviBaseColorSelector(QWidget *parent);
	~KviBaseColorSelector();
protected:
	int m_x;
	int m_y;
	QImage * m_pMemPix;
protected:
	void createGradient();
	virtual void drawContents(QPainter *p);
	virtual void mousePressEvent(QMouseEvent *e);
	virtual void mouseMoveEvent(QMouseEvent *e);
signals:
	void colorSelected(QRgb rgb);
};

class KviShadeColorSelector : public QFrame
{
	Q_OBJECT
public:
	KviShadeColorSelector(QWidget *parent);
	~KviShadeColorSelector();
protected:
	int m_y;
	QImage * m_pMemPix;
	QColor m_curBaseColor;
protected:
	virtual void drawContents(QPainter *p);
	virtual void mousePressEvent(QMouseEvent *e);
	virtual void mouseMoveEvent(QMouseEvent *e);
public slots:
	void setBaseColor(QRgb rgb);
signals:
	void colorSelected(QRgb rgb);
};

class KviColorDialog : public QDialog
{
	Q_OBJECT
public:
	KviColorDialog(const QColor &color);
	~KviColorDialog();
private:
	QColor m_curColor;
	QLabel * m_pSample;
	QLabel * m_pRed;
	QLabel * m_pGreen;
	QLabel * m_pBlue;
private:

public:
	const QColor & getCurrentColor(){ return m_pSample->backgroundColor(); };
private slots:
	void baseColorSelected(QRgb rgb);
};

#endif //!_KVI_COLORDIALOG_H_INCLUDED_
