//
//   File : kvi_imagefiledialog.cpp (/usr/build/NEW_kvirc/kvirc/src/kvilib/kvi_imagefiledialog.cpp)
//   Last major modification : Wed Mar 24 1999 13:41:47 by Szymon Stefanek
//
//   This file is part of the KVirc irc client distribution
//   Copyright (C) 1999-2000 Szymon Stefanek (stefanek@tin.it)
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
#include "kvi_imagefiledialog.h"
#include "kvi_locale.h"
#include <qpixmap.h>

KviImageFileDialog::KviImageFileDialog(const QString& startFileName, const QString& filter,
		 QWidget *parent,const char *name,bool modal)
:QFileDialog(QString::null,filter,parent,name,modal)
{
	m_pSampleLabel = new QLabel(this);
	m_pSampleLabel->setMinimumHeight(80);
	m_pSampleLabel->setMinimumWidth(200);
	m_pSampleLabel->setFrameStyle(QFrame::Sunken|QFrame::Panel);
	m_pSampleLabel->setAlignment(QLabel::AlignCenter);
	setCaption(__tr("Select image..."));
	addWidgets(m_pSampleLabel,0,0);
	setMode(QFileDialog::ExistingFile);
	connect(this,SIGNAL(fileHighlighted(const QString &)),this,SLOT(aFileWasHighlighted(const QString &)));
	connect(this,SIGNAL(dirEntered(const QString &)),this,SLOT(aFileWasHighlighted(const QString &)));
	setSelection(startFileName);
	aFileWasHighlighted(startFileName);
}

KviImageFileDialog::~KviImageFileDialog()
{
}

void KviImageFileDialog::aFileWasHighlighted(const QString &path)
{
	QPixmap pm(path);
	if(!pm.isNull()){
		m_pSampleLabel->setBackgroundPixmap(pm);
		m_pSampleLabel->setText("");
	} else {
		m_pSampleLabel->setBackgroundPixmap(QPixmap(0,0));
		m_pSampleLabel->setText(__tr("Unrecognized image format"));
	}
}


#include "m_kvi_imagefiledialog.moc"
