#ifndef _KVI_DIRBROWSER_H_INCLUDED_
#define _KVI_DIRBROWSER_H_INCLUDED_

//
//   File : kvi_dirbrowser.h (/usr/build/NEW_kvirc/kvirc/src/kvirc/kvi_dirbrowser.h)
//   Last major modification : Sun Apr 25 1999 13:57:12 by Szymon Stefanek
//
//   This file is part of the KVirc irc client distribution
//   Copyright (C) 1999-2000 Szymon Stefanek (stefanek@tin.it)
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

#include "kvi_string.h"

#include <qlistview.h>
#include <qdir.h>
#include <qpushbutton.h>
#include <qlabel.h>

class KviDirBrowser;

class KviDirView : public QListView
{
	Q_OBJECT
public:
	KviDirView(KviDirBrowser *parent);
	~KviDirView();
protected:
	bool m_bClickedInside;
	KviDirBrowser *m_pParent;
	void checkForDrag();
	virtual void contentsMouseMoveEvent(QMouseEvent *e);
	virtual void contentsMousePressEvent(QMouseEvent *e);
	virtual void contentsMouseReleaseEvent(QMouseEvent *e);
//	virtual void dropEvent(QDropEvent *e);
//	virtual void dragEnterEvent(QDragEnterEvent *e);
	virtual void enterEvent(QEvent *e);
	virtual void leaveEvent(QEvent *e);
};

class KviDirBrowser : public QWidget
{
	friend class KviDirView;
	friend class KviApp;
	Q_OBJECT
public:
	KviDirBrowser();
	~KviDirBrowser();
protected:
	KviDirView *m_pView;
	QDir      *m_pDir;
	QPushButton *m_pCdUp;
	QPushButton *m_pCdHome;
	QPushButton *m_pCdKVirc;
	QPushButton *m_pReload;
	QPushButton *m_pGoBookmark;
//	QPopupMenu  *m_pBookmarkMenu;
	QLabel *m_pStatus;
public:
	void openDirectory(const char *path);
	void getCurrentPath(KviStr &buffer);
protected:
	void fillView();
	virtual void closeEvent(QCloseEvent *);
	virtual void resizeEvent(QResizeEvent *);
protected slots:
	void itemDoubleClicked(QListViewItem *i);
	void currentItemChanged(QListViewItem *i);
	void cdUp();
	void cdHome();
	void reload();
	void cdKVirc();
//	void bookmarkCurrentDir();
	void showBookmarks();
//	void bookmarkSelected(int id);
};

#endif //!_KVI_DIRBROWSER_H_INCLUDED_
