#ifndef _KVI_DLGOPTIONS_H_INCLUDED_
#define _KVI_DLGOPTIONS_H_INCLUDED_

//
//   File : kvi_dlgoptions.h (/usr/build/NEW_kvirc/kvirc/src/kvirc/kvi_dlgoptions.h)
//   Last major modification : Tue May 4 1999 18:02:25 by Szymon Stefanek
//
//   This file is part of the KVirc irc client distribution
//   Copyright (C) 1999-2000 Szymon Stefanek (stefanek@tin.it)
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
#include "kvi_settings.h"

#include <qtabdialog.h>
#include <qlistview.h>

#include <qlistbox.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qcheckbox.h>

#include <qtabbar.h>
#include <qpainter.h>

class KviDoubleRowTabBar : public QTabBar
{
	Q_OBJECT
public:
	KviDoubleRowTabBar(QWidget * parent,const char *name = 0);
	~KviDoubleRowTabBar();
protected:
	QList<QTab> * m_pTabList; //HACK HACK HACK HACK HACK FOR QT
protected:
	void copyTabList(QList<QTab> * l);
	virtual void layoutTabs();
	virtual void setCurrentTab(int tab);
	virtual void setCurrentTab(QTab * tab);
	virtual void mouseReleaseEvent(QMouseEvent *e);
	virtual void paint(QPainter * p,QTab * t,bool selected) const;
//	virtual void paintEvent(QPaintEvent *e);
};

class KviListView;

class KviDlgOptMisc : public QTabDialog
{
	Q_OBJECT
public:
	KviDlgOptMisc();
	~KviDlgOptMisc();
protected:
	KviListView * m_pMimeView;
	KviListView * m_pStrSubView;
	QListView * m_pLogMsgTypesView;
#ifdef COMPILE_PLUGIN_SUPPORT
	QListBox * m_pPluginBox;
	QLabel * m_pPluginModuleNameLabel;
	QLabel * m_pPluginDescriptionLabel;
	QLabel * m_pPluginAuthorLabel;
	QLabel * m_pPluginVersionLabel;
	QLabel * m_pPluginServiceNameLabel;
	QPushButton * m_pUnloadPlugin;
	QPushButton * m_pConfigurePlugin;
	QPushButton * m_pHelpOnPlugin;
	QCheckBox * m_pPluginAutoloadCheck;
#endif
signals:
	void finished(bool bAccepted);
protected:
	virtual void done(int r);
	virtual void closeEvent(QCloseEvent *);
#ifdef COMPILE_PLUGIN_SUPPORT
	void fillPluginBox(unsigned int selectIdx = 0);
#endif
protected slots:
	void addNewString();
	void deleteSelectedStrings();
	void addNewMime();
	void deleteSelectedMimes();
	void logMsgTypeViewItemDoubleClicked(QListViewItem *it);

	void pluginListItemSelected(const QString &str);
	void pluginAutoloadToggled(bool bActive);
	void pluginLoad();
	void pluginUnload();
	void pluginConfigure();
	void pluginHelp();
};

#endif //!_KVI_DLGOPTIONS_H_INCLUDED_
