#ifndef _KVI_DNS_H_INCLUDED_
#define _KVI_DNS_H_INCLUDED_

//
//   File : kvi_dns.h (/usr/build/NEW_kvirc/kvirc/kvirc/kvi_dns.h)
//   Last major modification : Sun Jan 10 1999 18:54:30 by Szymon Stefanek
//
//   This file is part of the KVirc irc client distribution
//   Copyright (C) 1999-2000 Szymon Stefanek (stefanek@tin.it)
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

//#include "kvi_process.h"
#include "kvi_string.h"
//#include "kvi_settings.h"
/*
class KviDns : public KviProcess
{
	Q_OBJECT
public:
	KviDns(const char *host);
	~KviDns();
private:
	KviStr m_szDataBuffer;
	bool   m_bSuccess;
	KviStr m_szCommandline;
public:
	bool go();
	void getResult(KviStr &query,KviStr &hostname,KviStr &ip,KviStr &alias1,KviStr &alias2);
	void getError(KviStr &query,int *error_ptr);
signals:
	void finished(bool bSuccess,KviDns * this_ptr);
protected slots:
	void procFinished(KviProcess *,int retcode);
	void procOutput(KviProcess *,char *buffer,int buflen);
};

inline bool KviDns::go()
{ return run(m_szCommandline.ptr(),true,true); }
*/

// Threaded implementation

#include "kvi_thread.h"

#include <qtimer.h>

class KviAsyncDns;

typedef struct KviDnsStruct
{
	KviStr szHostToResolve;
	KviStr szHostname;
	KviStr szIp;
	KviStr szAlias1;
	KviStr szAlias2;
	KviAsyncDns * dnsParent;
	int iError;
	KviStr szData;
};

class KviAsyncDns : public QObject {
	Q_OBJECT
public:
	KviAsyncDns();
	~KviAsyncDns();
private:
	KviDnsStruct * m_dnsStruct;
	pthread_t m_thread;
public:
	bool resolve(const char * hostname,const char *data = 0);
protected:
	virtual bool event(QEvent *e);
signals:
	void dnsFinished(KviDnsStruct *);
};


#endif //_KVI_DNS_H_INCLUDED_
