//
//   File : kvi_ircview.cpp (/usr/build/NEW_kvirc/kvirc/src/kvirc/kvi_ircview.cpp)
//   Last major modification : Tue Jul 6 1999 14:45:20 by Szymon Stefanek
//
//   This file is part of the KVirc irc client distribution
//   Copyright (C) 1999-2000 Szymon Stefanek (stefanek@tin.it)
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

// Damn complex class ...but it works :)
// #include <brain.h>
//
// #define HOPE_THAT_IT_WILL_NEWER_NEED_TO_BE_MODIFIED :)

// 07 May 1999 , Already forgot how this damn thing works , and spent 1 hour over a stupid bug.
//		I had to recreate the whole thing in my mind......ooooouh...How did I wrote it ?
//      Just take a look to paintEvent() or to calculateLineWraps()...
//      Anyway...I've solved the bug.

// 23 Nov 1999 , Well , not so bad...I seem to still remember how it works
//      So just for fun , complicated the things a little bit more.
//      Added precaclucaltion of the text blocks and word wrapping
//      and a fast scrolling mode (3 lines at once) for consecutive
//      appendText() calls.
//      Now the code becomes really not understandable...:)

#define _KVI_IRCVIEW_CPP_

#define _KVI_DEBUG_CLASS_NAME_ "KviIrcView"
#define _KVI_DEBUG_CHECK_RANGE_

#include "kvi_debug.h"

#include "kvi_app.h"
#include "kvi_options.h"

#include "kvi_ircview.h"

#include "kvi_window.h"
#include "kvi_locale.h"
#include "kvi_frame.h"

#include "kvi_malloc.h"
#include "kvi_memmove.h"

#include "kvi_uparser.h"

#include <X11/Xlib.h>

#include <qbitmap.h>
#include <qcursor.h>
#include <qclipboard.h>
#include <qdatetime.h>
#include <qdragobject.h>


//Declared in kvi_app.cpp and managed by KviApp class
extern QPixmap * g_pixViewOut[KVI_OUT_NUM_IMAGES];
extern Display * g_display;
extern GC g_ircviewGC;
extern QPixmap * g_pIrcViewMemBuffer;
extern HANDLE g_hIrcViewMemBuffer;
extern QList<KviIrcView> * g_pIrcViewWidgetList;

#define KVI_IRCVIEW_BLOCK_SELECTION_TOTAL 0
#define KVI_IRCVIEW_BLOCK_SELECTION_LEFT 1
#define KVI_IRCVIEW_BLOCK_SELECTION_RIGHT 2
#define KVI_IRCVIEW_BLOCK_SELECTION_CENTRAL 3


/* FIXME: "PgUp and PgDn scrolls a fixed number of lines! Make it view height dependant" */

//================ getColorBytes ===============//

const char * getColorBytes(const char *data_ptr,char *byte_1,char *byte_2)
{
	//Scans the data_ptr for a mIrc color code XX,XX
	//and fills the color values in the two bytes

	//First we can have a digit or a coma
	if(((*data_ptr >= '0') && (*data_ptr <='9'))){
		//Something interesting ok.
		(*byte_1)=(*data_ptr)-'0'; //store the code
		data_ptr++;     //and check the next
		if(((*data_ptr >= '0') && (*data_ptr <= '9'))||(*data_ptr==',')){
			//Yes we can understand it
			if(*data_ptr==','){
				//A coma , need to check for background
				data_ptr++;
			} else {
				//A number
				(*byte_1)=((((*byte_1)*10)+((*data_ptr)-'0'))%16);
				data_ptr++;
				if(*data_ptr==','){
					//A coma , need to check for background
					data_ptr++;
				} else {
					//Senseless return
					(*byte_2)=KVI_NOCHANGE;
					return data_ptr;
				}
			}
		} else {
			//Senseless character control code OK and return
			(*byte_2)=KVI_NOCHANGE;
			return data_ptr;
		}
	} else {
		//Senseless character : only a CTRL+K code
		(*byte_1)=KVI_NOCHANGE;
		(*byte_2)=KVI_NOCHANGE;
		return data_ptr;
	}

	if((*data_ptr >= '0') && (*data_ptr <='9')){
		//Background , a color code
		(*byte_2)=(*data_ptr)-'0';
		data_ptr++;
		if((*data_ptr >= '0') && (*data_ptr <='9')){
			(*byte_2)=((((*byte_2)*10)+((*data_ptr)-'0'))%16);
			data_ptr++;
		}
		return data_ptr;
	} else {
		(*byte_2)=KVI_NOCHANGE;
		return data_ptr;
	}
}

//============ KviIrcView ============//

KviIrcView::KviIrcView(QWidget *parent,KviFrame *pFrm,KviWindow *pWnd)
:QWidget(parent)
{
	g_pIrcViewWidgetList->append(this); // register
	setBackgroundMode(NoBackground);
	resizeMemBuffer();

	m_pFirstLine               = 0;
	m_pCurLine                 = 0;
	m_pLastLine                = 0;
	m_iNumLines                = 0;
	m_iMaxLines                = g_pOptions->m_iViewMaxBufferSize;
	m_bAcceptDrops             = false;
//	m_pMemBuffer               = new QPixmap(width(),height());
	m_pPrivateBackgroundPixmap = 0;
	m_pScrollBar               = new QScrollBar(0,0,1,10,0,QScrollBar::Vertical,this);

	m_pScrollBar->setTracking(true);
	m_pScrollBar->show();
	m_pScrollBar->setFocusProxy(this);

	connect(m_pScrollBar,SIGNAL(valueChanged(int)),this,SLOT(scrollBarPositionChanged(int)));

	m_iLastScrollBarValue      = 0;
	m_bSelecting               = false;
	m_bDoubleClicked           = false;
	m_bShowImages              = g_pOptions->m_bShowImages;
	m_iSelectTimer             = 0;
	m_bTimestamp               = g_pOptions->m_bTimestamp;

	setFont(g_pOptions->m_fntView);

	m_szLastSelection          = "";
	m_szLastSelectionLine      = "";
	m_szLastDoubleClickedUrl   = "";
	m_bSkipScrollBarRepaint    = false;
	m_pLogFile                 = 0;
	m_pKviWindow               = pWnd;
	m_pFrm                     = pFrm;
	m_iUnprocessedPaintEventRequests = 0;
	m_bPostedPaintEventPending = false;
	setMinimumWidth(KVI_IRCVIEW_MINIMUM_WIDTH);
}

//============ ~KviIrcView ============//

KviIrcView::~KviIrcView()
{
	g_pIrcViewWidgetList->removeRef(this); // unregister

	if(m_iSelectTimer)killTimer(m_iSelectTimer);
	stopLogging();
	resizeMemBuffer(); //<--- we are no longer on the widget list
	if(m_pPrivateBackgroundPixmap)delete m_pPrivateBackgroundPixmap;
	emptyBuffer(false);
}

void KviIrcView::enableDnd(bool bEnable)
{
	setAcceptDrops(bEnable);
	m_bAcceptDrops = bEnable;
}

void KviIrcView::dragEnterEvent(QDragEnterEvent *e)
{
	if(!m_bAcceptDrops)return;
	e->accept(QUrlDrag::canDecode(e));
	emit dndEntered();
}

void KviIrcView::dropEvent(QDropEvent *e)
{
	if(!m_bAcceptDrops)return;
	QStringList list;
	if(QUrlDrag::decodeLocalFiles(e,list)){
		if(!list.isEmpty()){
			QStringList::ConstIterator it = list.begin(); //kewl ! :)
			for( ; it != list.end(); ++it ){
				KviStr tmp = *it; //wow :)
				if(*(tmp.ptr()) != '/')tmp.prepend("/"); //HACK HACK HACK for Qt bug (?!?)
				emit fileDropped(tmp.ptr());
			}
		}
	}
}

//============= stopLogging ===============//

void KviIrcView::stopLogging()
{
	if(m_pLogFile){
		KviStr szLogEnd(KviStr::Format,_i18n_("### Log session terminated at %s ###"),QDateTime::currentDateTime().toString().data());
		add2Log(szLogEnd.ptr());		
		m_pLogFile->close();
		delete m_pLogFile;
		m_pLogFile = 0;
	}
}

void KviIrcView::getTextBuffer(KviStr &buffer)
{
	buffer = "";
	if(!m_pLastLine)return;
	for(KviIrcViewTextLine *l=m_pFirstLine;l;l=l->next_line){
		buffer.append(l->data_ptr);
		buffer.append("\n");
	}
}

//=============== setParentKviWindow ===============//
//
//void KviIrcView::setParentKviWindow(KviWindow *pWin)
//{
//	m_pKviWindow = pWin;
//}

void KviIrcView::toggleLogging()
{
	if(isLogging())stopLogging();
	else {
		KviStr tmp;
		m_pKviWindow->getDefaultLogName(tmp);
		startLogging(tmp.ptr());
	}
}

void KviIrcView::logToFile()
{
	// Yeah....this is powerful! :)
	KviStr cmd = "/DIALOG (savefile,Choose a log file name,$deflogfile($window),$window) "\
		"if((\"$dialogresult\" != \"\")&&(\"$dialogmagic\" == \"$window\"))log on $dialogresult";
	m_pFrm->m_pUserParser->parseUserCommand(cmd,m_pKviWindow);
}

void KviIrcView::saveBufferToFile()
{
	// Yeah....this is powerful! :)
	KviStr cmd = "/DIALOG (savefile,Choose a file name,$deflogfile($window).savebuf,$window) "\
		"if(\"$dialogresult\" != \"\")window $dialogmagic savebuffer $dialogresult";
	m_pFrm->m_pUserParser->parseUserCommand(cmd,m_pKviWindow);
}

void KviIrcView::toggleTimestamp()
{
	setTimestamp(!timestamp());
}

void KviIrcView::toggleImages()
{
	setShowImages(!imagesVisible());
}

void KviIrcView::clearBuffer()
{
	emptyBuffer(true);
}

bool KviIrcView::saveBuffer(const char *filename)
{
//	debug("saving buffer to %s",filename);
	QFile f(filename);
	if(!f.open(IO_WriteOnly|IO_Truncate))return false;
	KviStr tmp;
	getTextBuffer(tmp);
	f.writeBlock(tmp.ptr(),tmp.len());
	f.close();
	return true;
}


//============== startLogging ===============//

bool KviIrcView::startLogging(const char *filename)
{
	stopLogging();


	m_pLogFile = new QFile(filename);
	if(m_pLogFile->exists()){
		if(!m_pLogFile->open(IO_Append|IO_WriteOnly)){
			delete m_pLogFile;
			m_pLogFile = 0;
			return false;
		}
	} else {
		if(!m_pLogFile->open(IO_WriteOnly)){
			delete m_pLogFile;
			m_pLogFile = 0;
			return false;
		}
	}
	KviStr szLogStart(KviStr::Format,_i18n_("### Log session started at %s ###"),QDateTime::currentDateTime().toString().data());
	add2Log(szLogStart.ptr());
	return true;
}

//=============== add2Log ==============//

void KviIrcView::add2Log(const char *buffer,int buf_len)
{
//	if(!m_pLogFile)return;
	if(buf_len<0)buf_len=strlen(buffer);
	if((m_pLogFile->writeBlock(buffer,buf_len)==-1)||(m_pLogFile->putch('\n')==-1))
			debug("WARNING : Can not write to the log file.");
}

//============== prevLine ==============//
void KviIrcView::prevLine(){ m_pScrollBar->subtractLine(); }
//============== nextLine ==============//
void KviIrcView::nextLine(){ m_pScrollBar->addLine(); }
//============== prevPage ==============//
void KviIrcView::prevPage(){
//	if(m_pTopLine){
//		// The top line must become the current one
//	} else m_pScrollBar->setPageSize(
	m_pScrollBar->subtractPage();
}
//============== nextLine ==============//
void KviIrcView::nextPage(){
	m_pScrollBar->addPage();
}

//============ setPrivateBackgroundPixmap ===========//

void KviIrcView::setPrivateBackgroundPixmap(const QPixmap &pixmap,bool bRepaint)
{
	if(m_pPrivateBackgroundPixmap){
		delete m_pPrivateBackgroundPixmap;
		m_pPrivateBackgroundPixmap=0;
	}
	if(!pixmap.isNull())m_pPrivateBackgroundPixmap = new QPixmap(pixmap);
	if(bRepaint)paintEvent(0);
}

//============= scrollBarPositionChanged=============//

void KviIrcView::scrollBarPositionChanged(int newValue)
{
	if(!m_pCurLine)return;
	int diff = 0;
	if(newValue > m_iLastScrollBarValue){
		while(newValue > m_iLastScrollBarValue){
			if(m_pCurLine->next_line){
				m_pCurLine=m_pCurLine->next_line;
				diff++;
			}
			m_iLastScrollBarValue++;
		}
	} else {
		while(newValue < m_iLastScrollBarValue){
			if(m_pCurLine->prev_line)m_pCurLine=m_pCurLine->prev_line;
			m_iLastScrollBarValue--;
		}
	}
	__range_valid(newValue == m_iLastScrollBarValue);
	if(!m_bSkipScrollBarRepaint)paintEvent(0);
//	{
//		if(g_pOptions->m_pixViewBack->isNull() && (!m_pPrivateBackgroundPixmap) && diff)fastScroll(diff);
//		else paintEvent(0);
//	}
}

//============= emptyBuffer ==============//

void KviIrcView::emptyBuffer(bool bRepaint)
{
	while(m_pLastLine != 0)removeHeadLine();
	if(bRepaint)paintEvent(0);
}

//============= setMaxBufferSize ===============//

void KviIrcView::setMaxBufferSize(int maxBufSize,bool bRepaint)
{
	if(maxBufSize < 32)maxBufSize = 32;
	m_iMaxLines = maxBufSize;
	while(m_iNumLines > m_iMaxLines)removeHeadLine();
	m_pScrollBar->setRange(0,m_iNumLines);
	if(bRepaint)paintEvent(0);
}

//================ setShowImages ===============//

void KviIrcView::setShowImages(bool bShow,bool bRepaint){
	if(m_bShowImages!=bShow){
		m_bShowImages=bShow;
		if(bRepaint)paintEvent(0);
	}
}

//================ setTimestamp ================//

void KviIrcView::setTimestamp(bool bTimestamp)
{
	m_bTimestamp = bTimestamp;
/*

// STATS FOR A BUFFER FULL OF HIGHLY COLORED STRINGS , HIGHLY WRAPPED
//
// Lines = 1024 (322425 bytes - 314 KB) (avg 314 bytes per line) , well :)
// string bytes = 87745 (85 KB)
// attributes = 3576 (42912 bytes - 41 KB)
// blocks = 12226 (146712 bytes - 143 KB)     

	unsigned long int nAlloc = 0;
	unsigned long int nLines = 0;
	unsigned long int nStringBytes = 0;
	unsigned long int nAttrBytes = 0;
	unsigned long int nBlockBytes = 0;
	unsigned long int nBlocks = 0;
	unsigned long int nAttributes = 0;
	KviIrcViewTextLine * l=m_pFirstLine;
	while(l){
		nLines++;
		nAlloc += sizeof(KviIrcViewTextLine);
		nStringBytes += l->data_len + 1;
		nAlloc += l->data_len + 1;
		nAlloc += (l->attr_len * sizeof(KviIrcViewTextAttribute));
		nAttrBytes +=(l->attr_len * sizeof(KviIrcViewTextAttribute));
		nAlloc += (l->num_text_blocks * sizeof(KviIrcViewTextAttribute));
		nBlockBytes += (l->num_text_blocks * sizeof(KviIrcViewTextAttribute));
		nBlocks += (l->num_text_blocks);
		nAttributes += (l->attr_len);
		l = l->next_line;
	}
	debug("\n\nLines = %u (%u bytes - %u KB) (avg %u bytes per line)",nLines,nAlloc,nAlloc / 1024,nLines ? (nAlloc / nLines) : 0);
	debug("string bytes = %u (%u KB)",nStringBytes,nStringBytes / 1024);
	debug("attributes = %u (%u bytes - %u KB)",nAttributes,nAttrBytes,nAttrBytes / 1024);
	debug("blocks = %u (%u bytes - %u KB)\n",nBlocks,nBlockBytes,nBlockBytes / 1024);
*/
}

//============= appendLine =============//

bool KviIrcView::event(QEvent *e)
{
	if(e->type() == QEvent::User){
		__range_valid(m_bPostedPaintEventPending);
		if(m_iUnprocessedPaintEventRequests)paintEvent(0);
		// else we just had a pointEvent that did the job
		m_bPostedPaintEventPending = false;
		return true;
	}
	return QWidget::event(e);
}

void KviIrcView::postUpdateEvent()
{

	if(!m_bPostedPaintEventPending){
		m_bPostedPaintEventPending = true;
		QEvent *e = new QEvent(QEvent::User);
		g_pApp->postEvent(this,e); // queue a repaint
	}
	m_iUnprocessedPaintEventRequests++; // paintEvent() will set it to 0
	if(m_iUnprocessedPaintEventRequests == 3){
		if(g_pOptions->m_pixViewBack->isNull() && (!m_pPrivateBackgroundPixmap))fastScroll(3);
		else paintEvent(0);
	}
}

void KviIrcView::appendLine(KviIrcViewTextLine *ptr,bool bRepaint)
{
	//This one appends a KviIrcViewTextLine to
	//the buffer list (at the end)
	__range_valid(ptr->data_ptr);
	if(m_pLastLine){
		m_pLastLine->next_line=ptr;
		ptr->prev_line  =m_pLastLine;
		ptr->next_line  =0;
		m_iNumLines++;
		if(m_iNumLines > m_iMaxLines){
			removeHeadLine();
			if(m_pCurLine==m_pLastLine){
				m_pCurLine=ptr;
				if(bRepaint)postUpdateEvent();
			} else {
				// the cur line remains the same
				// the scroll bar must move up one place to be in sync
				m_bSkipScrollBarRepaint = true;
				if(m_pScrollBar->value() > 0){
					m_iLastScrollBarValue--;
					__range_valid(m_iLastScrollBarValue >= 0);
					m_pScrollBar->subtractLine();
				} // else will stay in sync
				m_bSkipScrollBarRepaint = false;
			}
		} else {
			m_pScrollBar->setRange(0,m_iNumLines);
			if(m_pCurLine==m_pLastLine){
				m_bSkipScrollBarRepaint = true;
				m_pScrollBar->addLine();
				m_bSkipScrollBarRepaint = false;
				if(bRepaint)postUpdateEvent();
			}
		}
		m_pLastLine=ptr;
	} else {
		//First line
		m_pLastLine    = ptr;
		m_pFirstLine   = ptr;
		m_pCurLine     = ptr;
		ptr->prev_line = 0;
		ptr->next_line = 0;
		m_iNumLines    = 1;
		m_pScrollBar->setRange(0,1);
		m_pScrollBar->addLine();
		if(bRepaint)paintEvent(0);
	}

	if(m_pLogFile){
		if(g_pOptions->m_bLogMsgType[ptr->msg_type]){
			add2Log(ptr->data_ptr,ptr->data_len - 1);
		}
	}
}

//============== removeHeadLine ===============//

void KviIrcView::removeHeadLine(bool bRepaint)
{
	//Removes the first line of the text buffer
	if(!m_pLastLine)return;
	__range_valid(m_pFirstLine->prev_line==0);
	__range_valid(m_pFirstLine->data_ptr);
	kvi_free(m_pFirstLine->data_ptr);                      //free string data
	kvi_free(m_pFirstLine->attr_ptr);                      //free attributes data
	if(m_pFirstLine->num_text_blocks)kvi_free(m_pFirstLine->text_blocks_ptr);
	if(m_pFirstLine->next_line){
		KviIrcViewTextLine *aux_ptr=m_pFirstLine->next_line;//get the next line
		aux_ptr->prev_line=0;                          //becomes the first
		if(m_pFirstLine==m_pCurLine)m_pCurLine=aux_ptr;//move the cur line if necessary
		delete m_pFirstLine;                            //delete the struct
		m_pFirstLine=aux_ptr;                           //set the last
		m_iNumLines--;                                 //and decrement the count
	} else { //unique line
		m_pCurLine   = 0;
		m_pFirstLine = 0;
		m_iNumLines  = 0;
		delete m_pFirstLine;
		m_pLastLine  = 0;
	}
	if(bRepaint)paintEvent(0);
}

//============= appendText ===============//

void KviIrcView::appendText(int msg_type,const char *data_ptr,bool bRepaint)
{
	//appends a text string to the buffer list
	//splits the lines
	__range_valid(data_ptr);
	while(*data_ptr){                                         //Have more data
//		__debug__arg1("appending text %s",data_ptr);
		KviIrcViewTextLine *line_ptr=new KviIrcViewTextLine;  //create a line struct
		line_ptr->msg_type=msg_type;
		line_ptr->max_line_width=-1;
		line_ptr->num_text_blocks=0;
//		line_ptr->text_blocks_ptr=0;
		data_ptr=getTextLine(msg_type,data_ptr,line_ptr);
		appendLine(line_ptr,bRepaint);
	}
}

//============= getTextLine ===============//

const char * KviIrcView::getTextLine(int msg_type,const char * data_ptr,KviIrcViewTextLine *line_ptr)
{
	//Splits the text data in lines (separated by '\n')

	int buffer_pos_idx=0;       //we're at the beginning in the buffer
	int curAttrIdx = 0;
	int blockLen;
	register const char *p=data_ptr;

	//Alloc the first attribute
	line_ptr->attr_len = 1;
	line_ptr->attr_ptr = (KviIrcViewTextAttribute *)kvi_malloc(sizeof(KviIrcViewTextAttribute));
	//And fill it up
	line_ptr->attr_ptr[0].attribute = KVI_TEXT_COLOR;
	line_ptr->attr_ptr[0].block_idx = 0;

	if(m_bTimestamp){
		line_ptr->data_ptr = (char *)kvi_malloc(12);     //[hh:mm:ss]space\0
		line_ptr->data_len = 12;
		line_ptr->attr_ptr[0].block_len = 11;
		buffer_pos_idx     = 11;
		*(line_ptr->data_ptr)='[';
		kvi_fastmove((void *)(line_ptr->data_ptr+1),(void *)QTime::currentTime().toString().data(),8);
		*((line_ptr->data_ptr)+9)=']';
		*((line_ptr->data_ptr)+10)=' ';
	} else {
		line_ptr->data_ptr = (char *)kvi_malloc(1);      //at least terminator
		line_ptr->data_len = 1;
		line_ptr->attr_ptr[0].block_len = 0;
	}

	line_ptr->attr_ptr[0].attr_back = g_pOptions->m_cViewOutTypeBack[msg_type];
	line_ptr->attr_ptr[0].attr_fore = g_pOptions->m_cViewOutTypeFore[msg_type];

	for(;;){
		if(g_pOptions->m_bUrlHighlighting)while((((unsigned char)*p) > 31)&&(*p != 'h')&&(*p != 'f')&&(*p != 'w'))p++;
		else while(((unsigned char)*p) > 31)p++;
		switch(*p){
			case '\0':
				//Found the end of the string
				//Calculate the length of the last block
				blockLen = (p-data_ptr);
				//Update lengths
				line_ptr->data_len+=blockLen;
				line_ptr->attr_ptr[curAttrIdx].block_len+=blockLen;
				//Resize the data buffer
				line_ptr->data_ptr=(char *)kvi_realloc((void *)line_ptr->data_ptr,line_ptr->data_len);
				//Move the string data
				kvi_fastmove((void *)(line_ptr->data_ptr+buffer_pos_idx),(void *)data_ptr,blockLen);
				//move the buffer pointer to the end
				buffer_pos_idx+=blockLen;
				//terminate the string
				line_ptr->data_ptr[buffer_pos_idx]='\0';
				return p;
				break;
			case '\n':
				//Found the end of a line
				//Calculate the length of the last block
				blockLen = (p-data_ptr);
				//Update lengths
				line_ptr->data_len+=blockLen;
				line_ptr->attr_ptr[curAttrIdx].block_len+=blockLen;
				//Resize the data buffer
				line_ptr->data_ptr=(char *)kvi_realloc((void *)line_ptr->data_ptr,line_ptr->data_len);
				//Move the string data
				kvi_fastmove((void *)(line_ptr->data_ptr+buffer_pos_idx),(void *)data_ptr,blockLen);
				//move the buffer pointer to the end
				buffer_pos_idx+=blockLen;
				//terminate the string
				line_ptr->data_ptr[buffer_pos_idx]='\0';
				//move the current pointer to the next character...if it is '\0' we will simply stop
				p++;
				return p;
				break;
			case KVI_TEXT_BOLD:
			case KVI_TEXT_UNDERLINE:
			case KVI_TEXT_REVERSE:
			case KVI_TEXT_RESET:
				//Control code...need a new attribute struct
				//Found the end of a line
				//Calculate the length of the last block
				blockLen = (p-data_ptr);
				//Update lengths
				line_ptr->data_len+=blockLen;
				line_ptr->attr_ptr[curAttrIdx].block_len+=blockLen;
				//Resize the data buffer
				line_ptr->data_ptr=(char *)kvi_realloc((void *)line_ptr->data_ptr,line_ptr->data_len);
				//Move the string data
				kvi_fastmove((void *)(line_ptr->data_ptr+buffer_pos_idx),(void *)data_ptr,blockLen);
				//move the buffer pointer to the end
				buffer_pos_idx+=blockLen;
				//Create a new attribute block
				line_ptr->attr_len++;
				line_ptr->attr_ptr=(KviIrcViewTextAttribute *)kvi_realloc((void *)line_ptr->attr_ptr,
					line_ptr->attr_len * sizeof(KviIrcViewTextAttribute));
				curAttrIdx++;
				//And fill it up
				line_ptr->attr_ptr[curAttrIdx].attribute = *p;
				line_ptr->attr_ptr[curAttrIdx].block_idx = buffer_pos_idx;
				line_ptr->attr_ptr[curAttrIdx].block_len = 0;
				//move the current pointer to the next character...if it is '\0' we will simply stop
				data_ptr=++p;
				break;
			case KVI_TEXT_COLOR:
				//Color control code...need a new attribute struct
				//Calculate the length of the last block
				blockLen = (p-data_ptr);
				//Update lengths
				line_ptr->data_len+=blockLen;
				line_ptr->attr_ptr[curAttrIdx].block_len+=blockLen;
				//Resize the data buffer
				line_ptr->data_ptr=(char *)kvi_realloc((void *)line_ptr->data_ptr,line_ptr->data_len);
				//Move the string data
				kvi_fastmove((void *)(line_ptr->data_ptr+buffer_pos_idx),(void *)data_ptr,blockLen);
				//move the buffer pointer to the end
				buffer_pos_idx+=blockLen;
				//Create a new attribute block
				line_ptr->attr_len++;
				line_ptr->attr_ptr=(KviIrcViewTextAttribute *)kvi_realloc((void *)line_ptr->attr_ptr,
					line_ptr->attr_len * sizeof(KviIrcViewTextAttribute));
				curAttrIdx++;
				//And fill it up
				line_ptr->attr_ptr[curAttrIdx].attribute = *p;
				line_ptr->attr_ptr[curAttrIdx].block_idx = buffer_pos_idx;
				line_ptr->attr_ptr[curAttrIdx].block_len = 0;
				//move the current pointer to the next character...if it is '\0' we will simply stop
				p++;
				p=getColorBytes(p,&(line_ptr->attr_ptr[curAttrIdx].attr_fore),
								&(line_ptr->attr_ptr[curAttrIdx].attr_back));
				data_ptr=p;
				break;
			case 'h':
			case 'f':
				p++;
				if(*p == 't'){
					p--;
					if( (kvi_strEqualCSN(p,"ftp://",6)) ||
						(kvi_strEqualCSN(p,"http:/",6)) ||
						(kvi_strEqualCSN(p,"ftp.",4))   )
					{
						//Url highlighting block
						//Calculate the length of the last block
						blockLen = (p-data_ptr);
						//Update lengths
						line_ptr->data_len+=blockLen;
						line_ptr->attr_ptr[curAttrIdx].block_len+=blockLen;
						//Resize the data buffer
						line_ptr->data_ptr=(char *)kvi_realloc((void *)line_ptr->data_ptr,line_ptr->data_len);
						//Move the string data
						kvi_fastmove((void *)(line_ptr->data_ptr+buffer_pos_idx),(void *)data_ptr,blockLen);
						//move the buffer pointer to the end
						buffer_pos_idx+=blockLen;
						//Create a new attribute block
						line_ptr->attr_len++;
						line_ptr->attr_ptr=(KviIrcViewTextAttribute *)kvi_realloc((void *)line_ptr->attr_ptr,
							line_ptr->attr_len * sizeof(KviIrcViewTextAttribute));
						curAttrIdx++;
						//And fill it up
						line_ptr->attr_ptr[curAttrIdx].attribute = KVI_TEXT_URL_HIGHLIGHT;
						line_ptr->attr_ptr[curAttrIdx].block_idx = buffer_pos_idx;
						line_ptr->attr_ptr[curAttrIdx].block_len = 0;
						//move the current pointer after the 'http:/' block
						//and run until the presumed end of the url
						data_ptr=p;
						p+=6;
						//Question : What characters are NOT allowed in an URL ?
						//I assume [] () {} and chars below 33 (space too , and negative chars too! (for signed char systems))
						while((((unsigned char)*p) > 32) && (*p != '[') && (*p != ']') &&
								(*p != '(') && (*p != ')') && (*p != '{') && (*p != '}'))p++;
											//Calculate the length of the last block
						blockLen = (p-data_ptr);
						//Update lengths
						line_ptr->data_len+=blockLen;
						line_ptr->attr_ptr[curAttrIdx].block_len+=blockLen;
						//Resize the data buffer
						line_ptr->data_ptr=(char *)kvi_realloc((void *)line_ptr->data_ptr,line_ptr->data_len);
						//Move the string data
						kvi_fastmove((void *)(line_ptr->data_ptr+buffer_pos_idx),(void *)data_ptr,blockLen);
						//move the buffer pointer to the end
						buffer_pos_idx+=blockLen;
						//Create a new attribute block
						line_ptr->attr_len++;
						line_ptr->attr_ptr=(KviIrcViewTextAttribute *)kvi_realloc((void *)line_ptr->attr_ptr,
							line_ptr->attr_len * sizeof(KviIrcViewTextAttribute));
						curAttrIdx++;
						//And fill it up
						line_ptr->attr_ptr[curAttrIdx].attribute = KVI_TEXT_URL_UNHIGHLIGHT;
						line_ptr->attr_ptr[curAttrIdx].block_idx = buffer_pos_idx;
						line_ptr->attr_ptr[curAttrIdx].block_len = 0;
						data_ptr=p;
					} else p++;
				}
				break;
			case 'w':
				p++;
				if(*p == 'w'){
					p--;
					if( (kvi_strEqualCSN(p,"www.",4)))
					{
						//Url highlighting block
						//Calculate the length of the last block
						blockLen = (p-data_ptr);
						//Update lengths
						line_ptr->data_len+=blockLen;
						line_ptr->attr_ptr[curAttrIdx].block_len+=blockLen;
						//Resize the data buffer
						line_ptr->data_ptr=(char *)kvi_realloc((void *)line_ptr->data_ptr,line_ptr->data_len);
						//Move the string data
						kvi_fastmove((void *)(line_ptr->data_ptr+buffer_pos_idx),(void *)data_ptr,blockLen);
						//move the buffer pointer to the end
						buffer_pos_idx+=blockLen;
						//Create a new attribute block
						line_ptr->attr_len++;
						line_ptr->attr_ptr=(KviIrcViewTextAttribute *)kvi_realloc((void *)line_ptr->attr_ptr,
							line_ptr->attr_len * sizeof(KviIrcViewTextAttribute));
						curAttrIdx++;
						//And fill it up
						line_ptr->attr_ptr[curAttrIdx].attribute = KVI_TEXT_URL_HIGHLIGHT;
						line_ptr->attr_ptr[curAttrIdx].block_idx = buffer_pos_idx;
						line_ptr->attr_ptr[curAttrIdx].block_len = 0;
						//move the current pointer after the 'http:/' block
						//and run until the presumed end of the url
						data_ptr=p;
						p+=6;
						//Question : What characters are NOT allowed in an URL ?
						//I assume [] () {} and chars below 33 (space too , and negative chars too! (for signed char systems))
						while((((unsigned char)*p) > 32) && (*p != '[') && (*p != ']') &&
								(*p != '(') && (*p != ')') && (*p != '{') && (*p != '}'))p++;
											//Calculate the length of the last block
						blockLen = (p-data_ptr);
						//Update lengths
						line_ptr->data_len+=blockLen;
						line_ptr->attr_ptr[curAttrIdx].block_len+=blockLen;
						//Resize the data buffer
						line_ptr->data_ptr=(char *)kvi_realloc((void *)line_ptr->data_ptr,line_ptr->data_len);
						//Move the string data
						kvi_fastmove((void *)(line_ptr->data_ptr+buffer_pos_idx),(void *)data_ptr,blockLen);
						//move the buffer pointer to the end
						buffer_pos_idx+=blockLen;
						//Create a new attribute block
						line_ptr->attr_len++;
						line_ptr->attr_ptr=(KviIrcViewTextAttribute *)kvi_realloc((void *)line_ptr->attr_ptr,
							line_ptr->attr_len * sizeof(KviIrcViewTextAttribute));
						curAttrIdx++;
						//And fill it up
						line_ptr->attr_ptr[curAttrIdx].attribute = KVI_TEXT_URL_UNHIGHLIGHT;
						line_ptr->attr_ptr[curAttrIdx].block_idx = buffer_pos_idx;
						line_ptr->attr_ptr[curAttrIdx].block_len = 0;
						data_ptr=p;
					} else p++;
				}
				break;
			default:
				p++;
				break;
		}
	}
}

//================ drawBlockPart =================//

inline void KviIrcView::drawBlockPart(char curFore,char curBack,bool curBold,bool curUnderline,
		int curLeftCoord,int curBottomCoord,char *data,int len,int wdth)
{
	//A bit big to be inlined eh ?...:)
	__range_valid(curFore != KVI_TRANSPARENT);
	XSetForeground(g_display,g_ircviewGC,g_pOptions->m_pMircColor[(unsigned char)curFore]->pixel());
	if(curBack != KVI_TRANSPARENT){
		XSetBackground(g_display,g_ircviewGC,g_pOptions->m_pMircColor[(unsigned char)curBack]->pixel());
		XDrawImageString(g_display,g_hIrcViewMemBuffer,g_ircviewGC,curLeftCoord,curBottomCoord,data,len);
	} else XDrawString(g_display,g_hIrcViewMemBuffer,g_ircviewGC,curLeftCoord,curBottomCoord,data,len);
	if(curBold){ //Draw doubled font (simulate bold)
		XDrawString(g_display,g_hIrcViewMemBuffer,g_ircviewGC,curLeftCoord+1,curBottomCoord,data,len);
	}
	if(curUnderline){ //Draw a line under the text block....
		//if width is negative , it is the last block of a line
		if(wdth < 0)wdth=width()-(curLeftCoord+KVI_IRCVIEW_HORIZONTAL_BORDER+KVI_IRCVIEW_SCROLLBAR_WIDTH);
		XSetLineAttributes(g_display,g_ircviewGC,m_iFontLineWidth,LineSolid,CapButt,JoinMiter);
		XDrawLine(g_display,g_hIrcViewMemBuffer,g_ircviewGC,curLeftCoord,curBottomCoord,curLeftCoord+wdth,curBottomCoord);
	}
}

void KviIrcView::fastScroll(int lines)
{
//	__range_valid(lines > 0);
	m_iUnprocessedPaintEventRequests = 0;
	if(!isVisible())return;
	// Ok...the current line is the last one here
	// It is the only one that needs to be repainted
	int widgetWidth  = width()-KVI_IRCVIEW_SCROLLBAR_WIDTH;
	int widgetHeight = height();
	int maxLineWidth = widgetWidth;
	int defLeftCoord=KVI_IRCVIEW_HORIZONTAL_BORDER;
	if(m_bShowImages){
		maxLineWidth -= KVI_IRCVIEW_PIXMAP_SEPARATOR_AND_DOUBLEBORDER_WIDTH;
		defLeftCoord+=KVI_IRCVIEW_PIXMAP_AND_SEPARATOR;
	}
//	int heightToPaint = KVI_IRCVIEW_VERTICAL_BORDER + m_iFontDescent;
	int heightToPaint = 1;
	KviIrcViewTextLine * l = m_pCurLine;
	while(lines > 0){
		if(l){
			if(maxLineWidth != l->max_line_width)calculateLineWraps(l,maxLineWidth);
			heightToPaint += l->line_wraps * m_iFontLineSpacing;
			heightToPaint += (m_iFontLineSpacing + m_iFontDescent);
			lines--;
			l = l->prev_line;
		} else lines = 0;
	}

	XCopyArea(g_display,handle(),handle(),g_ircviewGC,
				1,heightToPaint,
				widgetWidth - 2,
				widgetHeight - (heightToPaint + KVI_IRCVIEW_VERTICAL_BORDER),
				1,1);
	QRect r(0,widgetHeight - (heightToPaint + KVI_IRCVIEW_VERTICAL_BORDER),
			widgetWidth,heightToPaint + KVI_IRCVIEW_VERTICAL_BORDER);

	QPaintEvent e(r);
	paintEvent(&e);
/*
	int topCoord = curBottomCoord - (m_iFontLineSpacing);
	//Draw the background
	XSetLineAttributes(g_display,gc_aux,0,LineSolid,CapButt,JoinMiter);
	XSetForeground(g_display,gc_aux,g_pOptions->m_clrViewBack.pixel());
	XSetBackground(g_display,gc_aux,g_pOptions->m_clrViewBack.pixel());
	XSetFillStyle(g_display,gc_aux,FillSolid );
	XSetFont(g_display,gc_aux,font().handle());
   	XFillRectangle(g_display,g_hIrcViewMemBuffer,gc_aux,1,topCoord,widgetWidth-2,lineHeight);

	//Make sure that we have enough space to paint something...
	if(maxLineWidth < ((m_iFontCharacterWidth['w'] << 1)+m_iWrapMargin))return;

	if(m_bShowImages){
		//Paint the pixmap first
		//Calculate the position of the image
		//imageYPos = curBottomCoord - (pixmapHeight(16) + ((m_iFontLineSpacing - 16)/2) );
		int imageYPos = curBottomCoord - ((m_iFontLineSpacing + 16) >> 1);
		//Set the mask if needed
		QPixmap *pix=g_pixViewOut[m_pCurLine->msg_type];
		if(pix->mask()){
			XSetClipMask(g_display,gc_aux,pix->mask()->handle());
			XSetClipOrigin(g_display,gc_aux,KVI_IRCVIEW_HORIZONTAL_BORDER,imageYPos);
		}
		//Draw the pixmap
		XCopyArea(g_display,pix->handle(),g_hIrcViewMemBuffer,gc_aux,0,0,16,16,KVI_IRCVIEW_HORIZONTAL_BORDER,imageYPos);
		XSetClipMask(g_display,gc_aux,None);
	}

	//Initialize for drawing this line of text
	char defaultBack  = m_pCurLine->text_blocks_ptr->attr_ptr->attr_back;
	char defaultFore  = m_pCurLine->text_blocks_ptr->attr_ptr->attr_fore;
	bool curBold      = false;
	bool curUnderline = false;
	char foreBeforeUrl= false;
	bool underlineBeforeUrl = false;
	char curFore      = defaultFore;
	char curBack      = defaultBack;
	int  curLeftCoord = defLeftCoord;
	curBottomCoord -= m_iFontDescent; //rise up the text...

	//Loop
	for(int i=0;i<m_pCurLine->num_text_blocks;i++){
		register KviIrcViewTextBlock * block = &(m_pCurLine->text_blocks_ptr[i]);

		if(block->attr_ptr){
			//normal block
			switch(block->attr_ptr->attribute){
				case KVI_TEXT_BOLD: curBold = !curBold; break;
				case KVI_TEXT_UNDERLINE: curUnderline = !curUnderline; break;
				case KVI_TEXT_RESET: curBold = false; curUnderline = false;
							curFore = defaultFore; curBack = defaultBack;
					break;
				case KVI_TEXT_URL_HIGHLIGHT: underlineBeforeUrl = curUnderline;
							foreBeforeUrl      = curFore; curUnderline       = true;
							curFore            = g_pOptions->m_cViewOutUrlFore;
					break;
				case KVI_TEXT_URL_UNHIGHLIGHT:
					curUnderline = underlineBeforeUrl;
					curFore      = foreBeforeUrl;
					break;
				case KVI_TEXT_REVERSE: //Huh ?
					if(curBack != KVI_TRANSPARENT){
						char aux=curFore;
						curFore = curBack;
						curBack = aux;
					} else {
						curBack = curFore;
						switch(curBack){
							case KVI_WHITE:
							case KVI_ORANGE:
							case KVI_YELLOW:
							case KVI_LIGHTGREEN:
							case KVI_BLUEMARINE:
							case KVI_LIGHTBLUE:
							case KVI_LIGHTVIOLET:
							case KVI_LIGHTGRAY:
								curFore=KVI_BLACK;
							break;
							default: //transparent too
								curFore=KVI_LIGHTGREEN;
							break;
						}
					}
					break;
				case KVI_TEXT_COLOR:
					if(block->attr_ptr->attr_fore != KVI_NOCHANGE)
						curFore = block->attr_ptr->attr_fore;
					if(block->attr_ptr->attr_back != KVI_NOCHANGE)
						curBack = block->attr_ptr->attr_back;
					break;
			}
		} else {
			//line wrap
			curLeftCoord=defLeftCoord;
			if(g_pOptions->m_bWrapMargin)curLeftCoord+=m_iWrapMargin;
			curBottomCoord+=m_iFontLineSpacing;
		}

//		__range_valid(curFore != KVI_TRANSPARENT);
		XSetForeground(g_display,gc_aux,g_pOptions->m_pMircColor[(unsigned char)curFore]->pixel());
		if(curBack != KVI_TRANSPARENT){
			XSetBackground(g_display,gc_aux,g_pOptions->m_pMircColor[(unsigned char)curBack]->pixel());
			XDrawImageString(g_display,g_hIrcViewMemBuffer,gc_aux,curLeftCoord,
				curBottomCoord,block->block_ptr,block->block_len);
		} else XDrawString(g_display,g_hIrcViewMemBuffer,gc_aux,curLeftCoord,
				curBottomCoord,block->block_ptr,block->block_len);
		if(curBold){ //Draw doubled font (simulate bold)
			XDrawString(g_display,g_hIrcViewMemBuffer,gc_aux,curLeftCoord+1,
				curBottomCoord,block->block_ptr,block->block_len);
		}
		if(curUnderline){ //Draw a line under the text block....
			int wdth = block->block_width;
			if(wdth == 0){
				// Last block before a word wrap , or a zero characters attribute block ?
				if(i < (m_pCurLine->num_text_blocks - 1)){
					// There is another block...
					// Check if it is a wrap...
					if(m_pCurLine->text_blocks_ptr[i+1].attr_ptr == 0)wdth = widgetWidth-(curLeftCoord+KVI_IRCVIEW_HORIZONTAL_BORDER);
					// else simply a zero characters block
				} // else simply a zero characters block : it is the last one!
			}
			XSetLineAttributes(g_display,gc_aux,m_iFontLineWidth,LineSolid,CapButt,JoinMiter);
			XDrawLine(g_display,g_hIrcViewMemBuffer,gc_aux,curLeftCoord,curBottomCoord,
				curLeftCoord+wdth,curBottomCoord);
		}
		curLeftCoord+=block->block_width;
	}
	//Need to draw the sunken rect around the view now...
	//COPY TO THE DISPLAY
	XCopyArea(g_display,g_hIrcViewMemBuffer,this->handle(),gc_aux,
		1,topCoord,widgetWidth-2,lineHeight-1,1,topCoord);

	XFreeGC(g_display,gc_aux);
*/
}

/*
void KviIrcView::paintEvent(QPaintEvent *p)
{
	//
	// THIS FUNCTION IS A MONSTER
	//

	if(!isVisible())return;

	int widgetWidth  = width() - KVI_IRCVIEW_SCROLLBAR_WIDTH;
	int widgetHeight = height();

	QRect r;

//	int rectLeft,rectTop,rectBottom,rectWidth,rectHeight;

	if(p)r=p->rect()
	else {
		// A self triggered event
		m_iUnprocessedPaintEventRequests = 0;
		r = rect();	
	}

	int rectLeft   = r.x();
	int rectTop    = r.y();
	int rectBottom = r.y() + r.height();
	int rectWidth  = r.width();
	if(rectWidth > widgetWidth)rectWidth = widgetWidth;
	int rectHeight = r.height();

	g_hIrcViewMemBuffer     = m_pMemBuffer->handle();
	GC       gc_aux  = XCreateGC(g_display,g_hIrcViewMemBuffer,0,0);

	//Draw the background
//	XSetLineAttributes(g_display,gc_aux,0,LineSolid,CapButt,JoinMiter); <--- default

	if(m_pPrivateBackgroundPixmap){
		XSetTile(g_display,gc_aux,m_pPrivateBackgroundPixmap->handle());
		XSetFillStyle(g_display,gc_aux,FillTiled);
	   	XFillRectangle(g_display,g_hIrcViewMemBuffer,gc_aux,rectLeft,rectTop,rectWidth,rectHeight);
		XSetFillStyle(g_display,gc_aux,FillSolid);
	} else {
		if(g_pOptions->m_pixViewBack->isNull()){
			XSetForeground(g_display,gc_aux,g_pOptions->m_clrViewBack.pixel());
			XSetBackground(g_display,gc_aux,g_pOptions->m_clrViewBack.pixel());
//			XSetFillStyle(g_display,gc_aux,FillSolid ); <--- default
		   	XFillRectangle(g_display,g_hIrcViewMemBuffer,gc_aux,rectLeft,rectTop,rectWidth,rectHeight);
		} else {
			XSetTile(g_display,gc_aux,g_pOptions->m_pixViewBack->handle());
			XSetFillStyle(g_display,gc_aux,FillTiled);
		   	XFillRectangle(g_display,g_hIrcViewMemBuffer,gc_aux,rectLeft,rectTop,rectWidth,rectHeight);
			XSetFillStyle(g_display,gc_aux,FillSolid);
		}
	}

	if(m_pCurLine){

		XSetFont(g_display,gc_aux,font().handle());

		//Have lines visible
		int curBottomCoord = widgetHeight - KVI_IRCVIEW_VERTICAL_BORDER;
		int maxLineWidth   = widgetWidth;
		int defLeftCoord=KVI_IRCVIEW_HORIZONTAL_BORDER;
		if(m_bShowImages){
			maxLineWidth -= KVI_IRCVIEW_PIXMAP_SEPARATOR_AND_DOUBLEBORDER_WIDTH;
			defLeftCoord+=KVI_IRCVIEW_PIXMAP_AND_SEPARATOR;
		}
		KviIrcViewTextLine *pCurTextLine = m_pCurLine;
		if(m_bSelecting){
			if(m_bDoubleClicked){
				m_szLastDoubleClickedUrl = "";
			} else {
				m_szLastSelectionLine   = "";
				m_szLastSelection       = "";
				m_iLastSelectionLineLen = 0;
			}
		}
		//Make sure that we have enough space to paint something...
		if(maxLineWidth < ((m_iFontCharacterWidth['w'] << 1)+m_iWrapMargin))pCurTextLine=0;

		//And loop thru lines until we not go over the upper bound of the view
//		debug("Rect %d,%d,%d,%d,%d,%d",r.x(),r.left(),r.y(),r.top(),r.width(),r.height());
		while((curBottomCoord >= KVI_IRCVIEW_VERTICAL_BORDER) && pCurTextLine){
			//Paint pCurTextLine
			if(maxLineWidth != pCurTextLine->max_line_width){
//				debug("Recalc for %d:%d (%s)",maxLineWidth,pCurTextLine->max_line_width,pCurTextLine->data_ptr);
				// Recalculate just if the width of the widget changed (or the font changed)
				calculateLineWraps(pCurTextLine,maxLineWidth);
			}

			curBottomCoord  -= (pCurTextLine->line_wraps) * m_iFontLineSpacing;

			if((curBottomCoord - m_iFontLineSpacing) > rectBottom){
				curBottomCoord -= (m_iFontLineSpacing + m_iFontDescent);
				pCurTextLine = pCurTextLine->prev_line;
				continue;
			}

//			debug("painting one line at %d",curBottomCoord);

			if(m_bShowImages){
				//Paint the pixmap first
				//Calculate the position of the image
				//imageYPos = curBottomCoord - (pixmapHeight(16) + ((m_iFontLineSpacing - 16)/2) );
				int imageYPos = curBottomCoord - ((m_iFontLineSpacing + 16) >> 1);
				//Set the mask if needed
				QPixmap *pix=g_pixViewOut[pCurTextLine->msg_type];
				if(pix->mask()){
					XSetClipMask(g_display,gc_aux,pix->mask()->handle());
					XSetClipOrigin(g_display,gc_aux,KVI_IRCVIEW_HORIZONTAL_BORDER,imageYPos);
				}
				//Draw the pixmap
				XCopyArea(g_display,pix->handle(),g_hIrcViewMemBuffer,gc_aux,0,0,16,16,KVI_IRCVIEW_HORIZONTAL_BORDER,imageYPos);
				XSetClipMask(g_display,gc_aux,None);
			}

			//Initialize for drawing this line of text
//			char defaultBack  = pCurTextLine->text_blocks_ptr[0].attr_ptr->attr_back;
//			char defaultFore  = pCurTextLine->text_blocks_ptr[0].attr_ptr->attr_fore;
			char defaultBack  = pCurTextLine->text_blocks_ptr->attr_ptr->attr_back;
			char defaultFore  = pCurTextLine->text_blocks_ptr->attr_ptr->attr_fore;
			bool curBold      = false;
			bool curUnderline = false;
			char foreBeforeUrl= false;
			bool underlineBeforeUrl = false;
			char curFore      = defaultFore;
			char curBack      = defaultBack;
			int  curLeftCoord = defLeftCoord;
			curBottomCoord -= m_iFontDescent; //rise up the text...
			//Loop
			for(int i=0;i < pCurTextLine->num_text_blocks;i++){
				register KviIrcViewTextBlock * block = &(pCurTextLine->text_blocks_ptr[i]);
				if(block->attr_ptr){
					//normal block
					switch(block->attr_ptr->attribute){
						case KVI_TEXT_BOLD:
							curBold = !curBold;
							break;
						case KVI_TEXT_UNDERLINE:
							curUnderline = !curUnderline;
							break;
						case KVI_TEXT_RESET:
							curBold = false;
							curUnderline = false;
							curFore = defaultFore;
							curBack = defaultBack;
							break;
						case KVI_TEXT_URL_HIGHLIGHT:
							underlineBeforeUrl = curUnderline;
							foreBeforeUrl      = curFore;
							curUnderline       = true;
							curFore            = g_pOptions->m_cViewOutUrlFore;
							break;
						case KVI_TEXT_URL_UNHIGHLIGHT:
							curUnderline = underlineBeforeUrl;
							curFore      = foreBeforeUrl;
							break;
						case KVI_TEXT_REVERSE: //Huh ?
							if(curBack != KVI_TRANSPARENT){
								char aux=curFore;
								curFore = curBack;
								curBack = aux;
							} else {
								curBack = curFore;
								switch(curBack){
									case KVI_WHITE:
									case KVI_ORANGE:
									case KVI_YELLOW:
									case KVI_LIGHTGREEN:
									case KVI_BLUEMARINE:
									case KVI_LIGHTBLUE:
									case KVI_LIGHTVIOLET:
									case KVI_LIGHTGRAY:
										curFore=KVI_BLACK;
										break;
									default: //transparent too
										curFore=KVI_LIGHTGREEN;
										break;
								}
							}
							break;
						case KVI_TEXT_COLOR:
							if(block->attr_ptr->attr_fore != KVI_NOCHANGE)
								curFore = block->attr_ptr->attr_fore;
							if(block->attr_ptr->attr_back != KVI_NOCHANGE)
								curBack = block->attr_ptr->attr_back;
							break;
					}
				} else {
					//line wrap
					curLeftCoord=defLeftCoord;
					if(g_pOptions->m_bWrapMargin)curLeftCoord+=m_iWrapMargin;
					curBottomCoord+=m_iFontLineSpacing;
				}
				if(m_bSelecting){ //Check if the block or a part of it is selected
					if(m_bDoubleClicked){
						checkForDoubleClickedUrl(pCurTextLine,curLeftCoord,curBottomCoord,i);
						goto no_selection_paint;
					} else {
						if(checkSelectionBlock(pCurTextLine,curLeftCoord,curBottomCoord,i)){
							//Selected in some way
							__range_valid(g_pOptions->m_cViewOutSeleFore != KVI_TRANSPARENT);
							__range_valid(g_pOptions->m_cViewOutSeleBack != KVI_TRANSPARENT);
							switch(m_TextBlockSelectionInfo.selection_type){
								case KVI_IRCVIEW_BLOCK_SELECTION_TOTAL:
									XSetForeground(g_display,gc_aux,g_pOptions->m_pMircColor[(unsigned char)g_pOptions->m_cViewOutSeleFore]->pixel());
									XSetBackground(g_display,gc_aux,g_pOptions->m_pMircColor[(unsigned char)g_pOptions->m_cViewOutSeleBack]->pixel());
									XDrawImageString(g_display,g_hIrcViewMemBuffer,gc_aux,curLeftCoord,
										curBottomCoord,block->block_ptr,block->block_len);
									//Append the block to the seleciton line
									m_szLastSelectionLine.setLen(m_iLastSelectionLineLen + block->block_len);
									kvi_fastmove(m_szLastSelectionLine.ptr()+m_iLastSelectionLineLen,(void *)(block->block_ptr),block->block_len);
									m_iLastSelectionLineLen += block->block_len;
									//And move to the next block
									curLeftCoord+= block->block_width;
									break;
								case KVI_IRCVIEW_BLOCK_SELECTION_LEFT:
									XSetForeground(g_display,gc_aux,g_pOptions->m_pMircColor[(unsigned char)g_pOptions->m_cViewOutSeleFore]->pixel());
									XSetBackground(g_display,gc_aux,g_pOptions->m_pMircColor[(unsigned char)g_pOptions->m_cViewOutSeleBack]->pixel());
									XDrawImageString(g_display,g_hIrcViewMemBuffer,gc_aux,curLeftCoord,
										curBottomCoord,block->block_ptr,m_TextBlockSelectionInfo.part_1_length);
									//Append the block to the seleciton line
									m_szLastSelectionLine.setLen(m_iLastSelectionLineLen + m_TextBlockSelectionInfo.part_1_length);
									kvi_fastmove(m_szLastSelectionLine.ptr()+m_iLastSelectionLineLen,(void *)block->block_ptr,m_TextBlockSelectionInfo.part_1_length);
									m_iLastSelectionLineLen +=m_TextBlockSelectionInfo.part_1_length;
									//And move to the next block
									curLeftCoord+=m_TextBlockSelectionInfo.part_1_width;
									drawBlockPart(gc_aux,
										curFore,curBack,curBold,curUnderline,curLeftCoord,curBottomCoord,
										block->block_ptr+m_TextBlockSelectionInfo.part_1_length,
										m_TextBlockSelectionInfo.part_2_length,
										m_TextBlockSelectionInfo.part_2_width);
									curLeftCoord+=m_TextBlockSelectionInfo.part_2_width;
									break;
								case KVI_IRCVIEW_BLOCK_SELECTION_RIGHT:
									drawBlockPart(gc_aux,
										curFore,curBack,curBold,curUnderline,curLeftCoord,curBottomCoord,
										block->block_ptr,
										m_TextBlockSelectionInfo.part_1_length,
										m_TextBlockSelectionInfo.part_1_width);
									curLeftCoord+=m_TextBlockSelectionInfo.part_1_width;
									XSetForeground(g_display,gc_aux,g_pOptions->m_pMircColor[(unsigned char)g_pOptions->m_cViewOutSeleFore]->pixel());
									XSetBackground(g_display,gc_aux,g_pOptions->m_pMircColor[(unsigned char)g_pOptions->m_cViewOutSeleBack]->pixel());
									XDrawImageString(g_display,g_hIrcViewMemBuffer,gc_aux,curLeftCoord,
										curBottomCoord,block->block_ptr+m_TextBlockSelectionInfo.part_1_length,m_TextBlockSelectionInfo.part_2_length);
									//Append the block to the seleciton line
									m_szLastSelectionLine.setLen(m_iLastSelectionLineLen + m_TextBlockSelectionInfo.part_2_length);
									kvi_fastmove(m_szLastSelectionLine.ptr()+m_iLastSelectionLineLen,
										block->block_ptr+m_TextBlockSelectionInfo.part_1_length,m_TextBlockSelectionInfo.part_2_length);
									m_iLastSelectionLineLen +=m_TextBlockSelectionInfo.part_2_length;
									//And move to the next block
									curLeftCoord+=m_TextBlockSelectionInfo.part_2_width;
									break;
								case KVI_IRCVIEW_BLOCK_SELECTION_CENTRAL:
									drawBlockPart(gc_aux,
										curFore,curBack,curBold,curUnderline,curLeftCoord,curBottomCoord,
										block->block_ptr,
										m_TextBlockSelectionInfo.part_1_length,
										m_TextBlockSelectionInfo.part_1_width);
									curLeftCoord+=m_TextBlockSelectionInfo.part_1_width;
									XSetForeground(g_display,gc_aux,g_pOptions->m_pMircColor[(unsigned char)g_pOptions->m_cViewOutSeleFore]->pixel());
									XSetBackground(g_display,gc_aux,g_pOptions->m_pMircColor[(unsigned char)g_pOptions->m_cViewOutSeleBack]->pixel());
									XDrawImageString(g_display,g_hIrcViewMemBuffer,gc_aux,curLeftCoord,
										curBottomCoord,pCurTextLine->text_blocks_ptr[i].block_ptr+m_TextBlockSelectionInfo.part_1_length,m_TextBlockSelectionInfo.part_2_length);
									//Append the block to the seleciton line
									m_szLastSelectionLine.setLen(m_iLastSelectionLineLen + m_TextBlockSelectionInfo.part_2_length);
									kvi_fastmove(m_szLastSelectionLine.ptr()+m_iLastSelectionLineLen,
										block->block_ptr+m_TextBlockSelectionInfo.part_1_length,m_TextBlockSelectionInfo.part_2_length);
//									debug("Last selection %s",m_szLastSelectionLine.ptr(),"Last selection len = %d",m_szLastSelectionLine.len());
									m_iLastSelectionLineLen +=m_TextBlockSelectionInfo.part_2_length;
									//And move to the next block
									curLeftCoord+=m_TextBlockSelectionInfo.part_2_width;
									drawBlockPart(gc_aux,
										curFore,curBack,curBold,curUnderline,curLeftCoord,curBottomCoord,
										block->block_ptr+m_TextBlockSelectionInfo.part_1_length+m_TextBlockSelectionInfo.part_2_length,
										m_TextBlockSelectionInfo.part_3_length,
										m_TextBlockSelectionInfo.part_3_width);
									curLeftCoord+=m_TextBlockSelectionInfo.part_3_width;
									break;
							}
						} else {
							int wdth = block->block_width;
							if(wdth == 0){
								// Last block before a word wrap , or a zero characters attribute block ?
								if(i < (pCurTextLine->num_text_blocks - 1)){
									// There is another block...
									// Check if it is a wrap...
									if(pCurTextLine->text_blocks_ptr[i+1].attr_ptr == 0)wdth = widgetWidth-(curLeftCoord+KVI_IRCVIEW_HORIZONTAL_BORDER);
									// else simply a zero characters block
								}
								// else simply a zero characters block
							}
							drawBlockPart(gc_aux,
								curFore,curBack,curBold,curUnderline,curLeftCoord,curBottomCoord,
								block->block_ptr,
								block->block_len,
								wdth);
							curLeftCoord+=block->block_width;
						}
					}
				} else {
					//No selection ...go fast!
no_selection_paint:
					__range_valid(curFore != KVI_TRANSPARENT);
					XSetForeground(g_display,gc_aux,g_pOptions->m_pMircColor[(unsigned char)curFore]->pixel());
					if(curBack != KVI_TRANSPARENT){
						XSetBackground(g_display,gc_aux,g_pOptions->m_pMircColor[(unsigned char)curBack]->pixel());
						XDrawImageString(g_display,g_hIrcViewMemBuffer,gc_aux,curLeftCoord,
							curBottomCoord,block->block_ptr,block->block_len);
					} else XDrawString(g_display,g_hIrcViewMemBuffer,gc_aux,curLeftCoord,
							curBottomCoord,block->block_ptr,block->block_len);
					if(curBold){ //Draw doubled font (simulate bold)
						XDrawString(g_display,g_hIrcViewMemBuffer,gc_aux,curLeftCoord+1,
							curBottomCoord,block->block_ptr,block->block_len);
					}
					if(curUnderline){ //Draw a line under the text block....
						int wdth = block->block_width;
						if(wdth == 0){
							// Last block before a word wrap , or a zero characters attribute block ?
							if(i < (pCurTextLine->num_text_blocks - 1)){
								// There is another block...
								// Check if it is a wrap...
								if(pCurTextLine->text_blocks_ptr[i+1].attr_ptr == 0)wdth = widgetWidth-(curLeftCoord+KVI_IRCVIEW_HORIZONTAL_BORDER);
								// else simply a zero characters block
							} // else simply a zero characters block : it is the last one!
						}
						XSetLineAttributes(g_display,gc_aux,m_iFontLineWidth,LineSolid,CapButt,JoinMiter);
						XDrawLine(g_display,g_hIrcViewMemBuffer,gc_aux,curLeftCoord,curBottomCoord,
							curLeftCoord+wdth,curBottomCoord);
					}
					curLeftCoord+=block->block_width;
				}
			}
			if(m_bSelecting && !m_bDoubleClicked){
				if(m_iLastSelectionLineLen > 0){
					if(m_szLastSelection.hasData())m_szLastSelection.prepend("\n");
					m_szLastSelection.prepend(m_szLastSelectionLine.ptr());
					m_szLastSelectionLine = "";
					m_iLastSelectionLineLen = 0;
				}
			}
			curBottomCoord -= (pCurTextLine->line_wraps+1) * m_iFontLineSpacing;
			pCurTextLine = pCurTextLine->prev_line;
		}
//		m_pTopLine = pCurTextLine; //remember the top line painted
	}

	//Need to draw the sunken rect around the view now...
	XSetLineAttributes(g_display,gc_aux,1,LineSolid,CapButt,JoinMiter);
	XSetForeground(g_display,gc_aux,colorGroup().dark().pixel());
	XDrawLine(g_display,g_hIrcViewMemBuffer,gc_aux,0,0,widgetWidth,0);
	XDrawLine(g_display,g_hIrcViewMemBuffer,gc_aux,0,0,0,widgetHeight);
	XSetForeground(g_display,gc_aux,colorGroup().light().pixel());
	XDrawLine(g_display,g_hIrcViewMemBuffer,gc_aux,1,widgetHeight-1,widgetWidth-1,widgetHeight-1);
	XDrawLine(g_display,g_hIrcViewMemBuffer,gc_aux,widgetWidth-1,1,widgetWidth-1,widgetHeight);

	//COPY TO THE DISPLAY
	XCopyArea(g_display,g_hIrcViewMemBuffer,this->handle(),gc_aux,rectLeft,rectTop,rectWidth,rectHeight,rectLeft,rectTop);
	XFreeGC(g_display,gc_aux);

}

*/

void KviIrcView::paintEvent(QPaintEvent *p)
{
	//
	// THIS FUNCTION IS A MONSTER
	//

	if(!isVisible())return;

	int widgetWidth  = width() - KVI_IRCVIEW_SCROLLBAR_WIDTH;
	int widgetHeight = height();

	QRect r;

	if(p)r=p->rect();
	else {
		// A self triggered event
		m_iUnprocessedPaintEventRequests = 0;
		r = rect();	
	}

	int rectLeft   = r.x();
	int rectTop    = r.y();
	int rectBottom = r.y() + r.height();
	int rectWidth  = r.width();
	if(rectWidth > widgetWidth)rectWidth = widgetWidth;
	int rectHeight = r.height();

	// evil XFillRectangle... 

	if(m_pPrivateBackgroundPixmap)
	{
		XSetTile(g_display,g_ircviewGC,m_pPrivateBackgroundPixmap->handle());
		XSetFillStyle(g_display,g_ircviewGC,FillTiled);
	   	XFillRectangle(g_display,g_hIrcViewMemBuffer,g_ircviewGC,rectLeft,rectTop,rectWidth,rectHeight);
		XSetFillStyle(g_display,g_ircviewGC,FillSolid);

	} else {
		if(g_pOptions->m_pixViewBack->isNull())
		{
			XSetForeground(g_display,g_ircviewGC,g_pOptions->m_clrViewBack.pixel());
			XSetBackground(g_display,g_ircviewGC,g_pOptions->m_clrViewBack.pixel());
		   	XFillRectangle(g_display,g_hIrcViewMemBuffer,g_ircviewGC,rectLeft,rectTop,rectWidth,rectHeight);
		} else {
			XSetTile(g_display,g_ircviewGC,g_pOptions->m_pixViewBack->handle());
			XSetFillStyle(g_display,g_ircviewGC,FillTiled);
		   	XFillRectangle(g_display,g_hIrcViewMemBuffer,g_ircviewGC,rectLeft,rectTop,rectWidth,rectHeight);
			XSetFillStyle(g_display,g_ircviewGC,FillSolid);
		}
	}

	XSetFont(g_display,g_ircviewGC,font().handle());

	//Have lines visible
	int curBottomCoord = widgetHeight - KVI_IRCVIEW_VERTICAL_BORDER;
	int maxLineWidth   = widgetWidth;
	int defLeftCoord   = KVI_IRCVIEW_HORIZONTAL_BORDER;
	int lineWrapsHeight;

	if(m_bShowImages){
		maxLineWidth -= KVI_IRCVIEW_PIXMAP_SEPARATOR_AND_DOUBLEBORDER_WIDTH;
		defLeftCoord += KVI_IRCVIEW_PIXMAP_AND_SEPARATOR;
	}

	KviIrcViewTextLine *pCurTextLine = m_pCurLine;

	if(m_bSelecting)
	{
		if(m_bDoubleClicked)
		{
			m_szLastDoubleClickedUrl = "";
		} else {
			m_szLastSelectionLine   = "";
			m_szLastSelection       = "";
			m_iLastSelectionLineLen = 0;
		}
	}

	//Make sure that we have enough space to paint something...
	if(maxLineWidth < ((m_iFontCharacterWidth['w'] << 1)+m_iWrapMargin))pCurTextLine=0;

	//And loop thru lines until we not run over the upper bound of the view
	while((curBottomCoord >= KVI_IRCVIEW_VERTICAL_BORDER) && pCurTextLine)
	{
		//Paint pCurTextLine
		if(maxLineWidth != pCurTextLine->max_line_width)
		{
			// Width of the widget or the font has been changed
			// from the last time that this line was painted
			calculateLineWraps(pCurTextLine,maxLineWidth);
		}

		// the evil multiplication
		// in an i486 it can get up to 42 clock cycles
		lineWrapsHeight  = (pCurTextLine->line_wraps) * m_iFontLineSpacing;
		curBottomCoord  -= lineWrapsHeight;

		if((curBottomCoord - m_iFontLineSpacing) > rectBottom)
		{
			// not in update rect... skip
			curBottomCoord -= (m_iFontLineSpacing + m_iFontDescent);
			pCurTextLine = pCurTextLine->prev_line;
			continue;
		}

		if(m_bShowImages)
		{
			//Paint the pixmap first
			//Calculate the position of the image
			//imageYPos = curBottomCoord - (pixmapHeight(16) + ((m_iFontLineSpacing - 16)/2) );
			int imageYPos = curBottomCoord - ((m_iFontLineSpacing + 16) >> 1);
			//Set the mask if needed
			QPixmap *pix = g_pixViewOut[pCurTextLine->msg_type];
			if(pix->mask()){
				XSetClipMask(g_display,g_ircviewGC,pix->mask()->handle());
				XSetClipOrigin(g_display,g_ircviewGC,KVI_IRCVIEW_HORIZONTAL_BORDER,imageYPos);
			}
			//Draw the pixmap
			XCopyArea(g_display,pix->handle(),g_hIrcViewMemBuffer,g_ircviewGC,0,0,16,16,KVI_IRCVIEW_HORIZONTAL_BORDER,imageYPos);
			XSetClipMask(g_display,g_ircviewGC,None);
		}

		//Initialize for drawing this line of text
//		char defaultBack  = pCurTextLine->text_blocks_ptr[0].attr_ptr->attr_back;
//		char defaultFore  = pCurTextLine->text_blocks_ptr[0].attr_ptr->attr_fore;
		char defaultBack  = pCurTextLine->text_blocks_ptr->attr_ptr->attr_back;
		char defaultFore  = pCurTextLine->text_blocks_ptr->attr_ptr->attr_fore;
		bool curBold      = false;
		bool curUnderline = false;
		char foreBeforeUrl= false;
		bool underlineBeforeUrl = false;
		char curFore      = defaultFore;
		char curBack      = defaultBack;
		int  curLeftCoord = defLeftCoord;
		curBottomCoord   -= m_iFontDescent; //rise up the text...

		//
		// Single text line loop (paint all text blocks)
		// (May correspond to more physical lines on the display if the text is wrapped)
		//

		for(int i=0;i < pCurTextLine->num_text_blocks;i++)
		{

			register KviIrcViewTextBlock * block = &(pCurTextLine->text_blocks_ptr[i]);

			// Play with the attributes

			if(block->attr_ptr)
			{
				//normal block
				switch(block->attr_ptr->attribute)
				{
					case KVI_TEXT_BOLD:
						curBold            = !curBold;
						break;
					case KVI_TEXT_UNDERLINE:
						curUnderline       = !curUnderline;
						break;
					case KVI_TEXT_RESET:
						curBold            = false;
						curUnderline       = false;
						curFore            = defaultFore;
						curBack            = defaultBack;
						break;
					case KVI_TEXT_URL_HIGHLIGHT:
						underlineBeforeUrl = curUnderline;
						foreBeforeUrl      = curFore;
						curUnderline       = true;
						curFore            = g_pOptions->m_cViewOutUrlFore;
						break;
					case KVI_TEXT_URL_UNHIGHLIGHT:
						curUnderline       = underlineBeforeUrl;
						curFore            = foreBeforeUrl;
						break;
					case KVI_TEXT_REVERSE: //Huh ?
						if(curBack != KVI_TRANSPARENT)
						{
							char aux       =curFore;
							curFore        = curBack;
							curBack        = aux;
						} else {
							curBack = curFore;
							switch(curBack)
							{
								case KVI_WHITE:
								case KVI_ORANGE:
								case KVI_YELLOW:
								case KVI_LIGHTGREEN:
								case KVI_BLUEMARINE:
								case KVI_LIGHTBLUE:
								case KVI_LIGHTVIOLET:
								case KVI_LIGHTGRAY:
									curFore=KVI_BLACK;
									break;
								default: //transparent too
									curFore=KVI_LIGHTGREEN;
									break;
							}
						}
						break;
					case KVI_TEXT_COLOR:
						if(block->attr_ptr->attr_fore != KVI_NOCHANGE)
							curFore = block->attr_ptr->attr_fore;
						if(block->attr_ptr->attr_back != KVI_NOCHANGE)
							curBack = block->attr_ptr->attr_back;
						break;
				}

			} else {

				// no attributes , it is a line wrap
				curLeftCoord = defLeftCoord;
				if(g_pOptions->m_bWrapMargin)curLeftCoord+=m_iWrapMargin;
				curBottomCoord += m_iFontLineSpacing;

			}

			if(m_bSelecting)
			{ //Check if the block or a part of it is selected
				if(m_bDoubleClicked)
				{
					checkForDoubleClickedUrl(pCurTextLine,curLeftCoord,curBottomCoord,i);
					goto no_selection_paint;
				} else {
					if(checkSelectionBlock(pCurTextLine,curLeftCoord,curBottomCoord,i))
					{
						//Selected in some way
						__range_valid(g_pOptions->m_cViewOutSeleFore != KVI_TRANSPARENT);
						__range_valid(g_pOptions->m_cViewOutSeleBack != KVI_TRANSPARENT);
						switch(m_TextBlockSelectionInfo.selection_type){
							case KVI_IRCVIEW_BLOCK_SELECTION_TOTAL:
								XSetForeground(g_display,g_ircviewGC,g_pOptions->m_pMircColor[(unsigned char)g_pOptions->m_cViewOutSeleFore]->pixel());
								XSetBackground(g_display,g_ircviewGC,g_pOptions->m_pMircColor[(unsigned char)g_pOptions->m_cViewOutSeleBack]->pixel());
								XDrawImageString(g_display,g_hIrcViewMemBuffer,g_ircviewGC,curLeftCoord,
									curBottomCoord,block->block_ptr,block->block_len);
								//Append the block to the seleciton line
								m_szLastSelectionLine.setLen(m_iLastSelectionLineLen + block->block_len);
								kvi_fastmove(m_szLastSelectionLine.ptr()+m_iLastSelectionLineLen,(void *)(block->block_ptr),block->block_len);
								m_iLastSelectionLineLen += block->block_len;
								//And move to the next block
								curLeftCoord+= block->block_width;
								break;
							case KVI_IRCVIEW_BLOCK_SELECTION_LEFT:
								XSetForeground(g_display,g_ircviewGC,g_pOptions->m_pMircColor[(unsigned char)g_pOptions->m_cViewOutSeleFore]->pixel());
								XSetBackground(g_display,g_ircviewGC,g_pOptions->m_pMircColor[(unsigned char)g_pOptions->m_cViewOutSeleBack]->pixel());
								XDrawImageString(g_display,g_hIrcViewMemBuffer,g_ircviewGC,curLeftCoord,
									curBottomCoord,block->block_ptr,m_TextBlockSelectionInfo.part_1_length);
								//Append the block to the seleciton line
								m_szLastSelectionLine.setLen(m_iLastSelectionLineLen + m_TextBlockSelectionInfo.part_1_length);
								kvi_fastmove(m_szLastSelectionLine.ptr()+m_iLastSelectionLineLen,(void *)block->block_ptr,m_TextBlockSelectionInfo.part_1_length);
								m_iLastSelectionLineLen +=m_TextBlockSelectionInfo.part_1_length;
								//And move to the next block
								curLeftCoord+=m_TextBlockSelectionInfo.part_1_width;
								drawBlockPart(
									curFore,curBack,curBold,curUnderline,curLeftCoord,curBottomCoord,
									block->block_ptr+m_TextBlockSelectionInfo.part_1_length,
									m_TextBlockSelectionInfo.part_2_length,
									m_TextBlockSelectionInfo.part_2_width);
								curLeftCoord+=m_TextBlockSelectionInfo.part_2_width;
								break;
							case KVI_IRCVIEW_BLOCK_SELECTION_RIGHT:
								drawBlockPart(
									curFore,curBack,curBold,curUnderline,curLeftCoord,curBottomCoord,
									block->block_ptr,
									m_TextBlockSelectionInfo.part_1_length,
									m_TextBlockSelectionInfo.part_1_width);
								curLeftCoord+=m_TextBlockSelectionInfo.part_1_width;
								XSetForeground(g_display,g_ircviewGC,g_pOptions->m_pMircColor[(unsigned char)g_pOptions->m_cViewOutSeleFore]->pixel());
								XSetBackground(g_display,g_ircviewGC,g_pOptions->m_pMircColor[(unsigned char)g_pOptions->m_cViewOutSeleBack]->pixel());
								XDrawImageString(g_display,g_hIrcViewMemBuffer,g_ircviewGC,curLeftCoord,
									curBottomCoord,block->block_ptr+m_TextBlockSelectionInfo.part_1_length,m_TextBlockSelectionInfo.part_2_length);
								//Append the block to the seleciton line
								m_szLastSelectionLine.setLen(m_iLastSelectionLineLen + m_TextBlockSelectionInfo.part_2_length);
								kvi_fastmove(m_szLastSelectionLine.ptr()+m_iLastSelectionLineLen,
									block->block_ptr+m_TextBlockSelectionInfo.part_1_length,m_TextBlockSelectionInfo.part_2_length);
								m_iLastSelectionLineLen +=m_TextBlockSelectionInfo.part_2_length;
								//And move to the next block
								curLeftCoord+=m_TextBlockSelectionInfo.part_2_width;
								break;
							case KVI_IRCVIEW_BLOCK_SELECTION_CENTRAL:
								drawBlockPart(
									curFore,curBack,curBold,curUnderline,curLeftCoord,curBottomCoord,
									block->block_ptr,
									m_TextBlockSelectionInfo.part_1_length,
									m_TextBlockSelectionInfo.part_1_width);
								curLeftCoord+=m_TextBlockSelectionInfo.part_1_width;
								XSetForeground(g_display,g_ircviewGC,g_pOptions->m_pMircColor[(unsigned char)g_pOptions->m_cViewOutSeleFore]->pixel());
								XSetBackground(g_display,g_ircviewGC,g_pOptions->m_pMircColor[(unsigned char)g_pOptions->m_cViewOutSeleBack]->pixel());
								XDrawImageString(g_display,g_hIrcViewMemBuffer,g_ircviewGC,curLeftCoord,
									curBottomCoord,pCurTextLine->text_blocks_ptr[i].block_ptr+m_TextBlockSelectionInfo.part_1_length,m_TextBlockSelectionInfo.part_2_length);
								//Append the block to the seleciton line
								m_szLastSelectionLine.setLen(m_iLastSelectionLineLen + m_TextBlockSelectionInfo.part_2_length);
								kvi_fastmove(m_szLastSelectionLine.ptr()+m_iLastSelectionLineLen,
									block->block_ptr+m_TextBlockSelectionInfo.part_1_length,m_TextBlockSelectionInfo.part_2_length);
//									debug("Last selection %s",m_szLastSelectionLine.ptr(),"Last selection len = %d",m_szLastSelectionLine.len());
								m_iLastSelectionLineLen +=m_TextBlockSelectionInfo.part_2_length;
								//And move to the next block
								curLeftCoord+=m_TextBlockSelectionInfo.part_2_width;
								drawBlockPart(
									curFore,curBack,curBold,curUnderline,curLeftCoord,curBottomCoord,
									block->block_ptr+m_TextBlockSelectionInfo.part_1_length+m_TextBlockSelectionInfo.part_2_length,
									m_TextBlockSelectionInfo.part_3_length,
									m_TextBlockSelectionInfo.part_3_width);
								curLeftCoord+=m_TextBlockSelectionInfo.part_3_width;
								break;
						}
					} else {
						int wdth = block->block_width;
						if(wdth == 0){
							// Last block before a word wrap , or a zero characters attribute block ?
							if(i < (pCurTextLine->num_text_blocks - 1)){
								// There is another block...
								// Check if it is a wrap...
								if(pCurTextLine->text_blocks_ptr[i+1].attr_ptr == 0)wdth = widgetWidth-(curLeftCoord+KVI_IRCVIEW_HORIZONTAL_BORDER);
								// else simply a zero characters block
							}
							// else simply a zero characters block
						}
						drawBlockPart(
							curFore,curBack,curBold,curUnderline,curLeftCoord,curBottomCoord,
							block->block_ptr,
							block->block_len,
							wdth);
						curLeftCoord+=block->block_width;
					}
				}
			} else {
				//No selection ...go fast!
no_selection_paint:
//				__range_valid(curFore != KVI_TRANSPARENT);
				XSetForeground(g_display,g_ircviewGC,g_pOptions->m_pMircColor[(unsigned char)curFore]->pixel());
				if(curBack != KVI_TRANSPARENT)
				{
					XSetBackground(g_display,g_ircviewGC,g_pOptions->m_pMircColor[(unsigned char)curBack]->pixel());
					XDrawImageString(g_display,g_hIrcViewMemBuffer,g_ircviewGC,curLeftCoord,
						curBottomCoord,block->block_ptr,block->block_len);
				} else {
					XDrawString(g_display,g_hIrcViewMemBuffer,g_ircviewGC,curLeftCoord,
						curBottomCoord,block->block_ptr,block->block_len);
				}
				if(curBold)
				{ //Draw doubled font (simulate bold)
					XDrawString(g_display,g_hIrcViewMemBuffer,g_ircviewGC,curLeftCoord+1,
						curBottomCoord,block->block_ptr,block->block_len);
				}
				if(curUnderline)
				{ //Draw a line under the text block....
					int wdth = block->block_width;
					if(wdth == 0)
					{
						// Last block before a word wrap , or a zero characters attribute block ?
						if(i < (pCurTextLine->num_text_blocks - 1))
						{
							// There is another block...
							// Check if it is a wrap...
							if(pCurTextLine->text_blocks_ptr[i+1].attr_ptr == 0)wdth = widgetWidth-(curLeftCoord+KVI_IRCVIEW_HORIZONTAL_BORDER);
							// else simply a zero characters block
						} // else simply a zero characters block : it is the last one!
					}
					XSetLineAttributes(g_display,g_ircviewGC,m_iFontLineWidth,LineSolid,CapButt,JoinMiter);
					XDrawLine(g_display,g_hIrcViewMemBuffer,g_ircviewGC,curLeftCoord,curBottomCoord,
						curLeftCoord+wdth,curBottomCoord);
				}
				curLeftCoord += block->block_width;
			}
		}

		if(m_bSelecting && !m_bDoubleClicked){
			if(m_iLastSelectionLineLen > 0){
				if(m_szLastSelection.hasData())m_szLastSelection.prepend("\n");
				m_szLastSelection.prepend(m_szLastSelectionLine.ptr());
				m_szLastSelectionLine = "";
				m_iLastSelectionLineLen = 0;
			}
		}

		curBottomCoord -= (lineWrapsHeight + m_iFontLineSpacing);
		pCurTextLine    = pCurTextLine->prev_line;
	}

	//Need to draw the sunken rect around the view now...
	XSetLineAttributes(g_display,g_ircviewGC,1,LineSolid,CapButt,JoinMiter); //need this for line size
	XSetForeground(g_display,g_ircviewGC,colorGroup().dark().pixel());
	XDrawLine(g_display,g_hIrcViewMemBuffer,g_ircviewGC,0,0,widgetWidth,0);
	XDrawLine(g_display,g_hIrcViewMemBuffer,g_ircviewGC,0,0,0,widgetHeight);
	XSetForeground(g_display,g_ircviewGC,colorGroup().light().pixel());
	XDrawLine(g_display,g_hIrcViewMemBuffer,g_ircviewGC,1,widgetHeight-1,widgetWidth-1,widgetHeight-1);
	XDrawLine(g_display,g_hIrcViewMemBuffer,g_ircviewGC,widgetWidth-1,1,widgetWidth-1,widgetHeight);

	// COPY TO THE DISPLAY
	// EVIL XCopyArea... it takes soooo long.
	XCopyArea(g_display,g_hIrcViewMemBuffer,this->handle(),g_ircviewGC,rectLeft,rectTop,rectWidth,rectHeight,rectLeft,rectTop);
//	XFreeGC(g_display,g_ircviewGC);
}


//============ calculateLineWraps ==============//

void KviIrcView::calculateLineWraps(KviIrcViewTextLine *ptr,int maxWidth)
{
	if(ptr->num_text_blocks != 0)kvi_free(ptr->text_blocks_ptr); // free any previous wrap blocks
	ptr->text_blocks_ptr=(KviIrcViewTextBlock *)kvi_malloc(sizeof(KviIrcViewTextBlock)); // alloc one block
	ptr->max_line_width = maxWidth;                              // calculus for this width
	ptr->num_text_blocks = 0; // it will be ++
	ptr->line_wraps = 0;      // no line wraps yet
	int curAttrBlock=0; //Current attribute block
	int curLineWidth=0;

	// init the first block
	ptr->text_blocks_ptr->block_ptr = ptr->data_ptr;
	ptr->text_blocks_ptr->block_len = 0;
	ptr->text_blocks_ptr->block_width = 0;
	ptr->text_blocks_ptr->attr_ptr  = &(ptr->attr_ptr[0]);

//	int maxBlockLen = ptr->text_blocks_ptr[ptr->num_text_blocks].attr_ptr->block_len;
	int maxBlockLen = ptr->attr_ptr->block_len; // ptr->attr_ptr[0].block_len

	for(;;){
		//Calculate the block_width
		register char *p=ptr->text_blocks_ptr[ptr->num_text_blocks].block_ptr;
//		KviIrcViewTextBlock * blk = ptr->text_blocks_ptr[ptr->num_text_blocks];
		int curBlockLen   = 0;
		int curBlockWidth = 0;
		while(curBlockLen < maxBlockLen){
			curBlockWidth += m_iFontCharacterWidth[((unsigned char)*p)];
			curBlockLen++;
			p++;
		}
		//Check the length
		curLineWidth += curBlockWidth;
		if(curLineWidth < maxWidth){
			//Ok....proceed to next block
			ptr->text_blocks_ptr[ptr->num_text_blocks].block_len   = curBlockLen;
			ptr->text_blocks_ptr[ptr->num_text_blocks].block_width = curBlockWidth;
			curAttrBlock++;
			ptr->num_text_blocks++;
			ptr->text_blocks_ptr = (KviIrcViewTextBlock *)kvi_realloc(ptr->text_blocks_ptr,(ptr->num_text_blocks + 1) * sizeof(KviIrcViewTextBlock));
//			if(ptr->num_text_blocks >= KVI_IRCVIEW_MAX_TEXT_BLOCKS)return ptr->line_wraps;
			//Process the next block of data in the next loop or return if have no more blocks
			if(curAttrBlock < ptr->attr_len){
				ptr->text_blocks_ptr[ptr->num_text_blocks].block_ptr = &(ptr->data_ptr[ptr->attr_ptr[curAttrBlock].block_idx]);
				ptr->text_blocks_ptr[ptr->num_text_blocks].block_len = 0;
				ptr->text_blocks_ptr[ptr->num_text_blocks].block_width = 0;
				ptr->text_blocks_ptr[ptr->num_text_blocks].attr_ptr  = &(ptr->attr_ptr[curAttrBlock]);
				maxBlockLen = ptr->text_blocks_ptr[ptr->num_text_blocks].attr_ptr->block_len;
			} else return;
		} else {
			//Need word wrap
			//First go back to a admissible width
			while((curLineWidth >= maxWidth) && curBlockLen){
				p--;
				curBlockLen--;
				curLineWidth-=m_iFontCharacterWidth[((unsigned char)*p)];
			}
			//Now look for a space
			while((*p != ' ') && curBlockLen){ 
				p--;
				curBlockLen--;
				curLineWidth-=m_iFontCharacterWidth[((unsigned char)*p)];
			}
			//If we ran up to the beginning of the block....
			if(curBlockLen == 0){
				//Don't like it....forced wrap here...
				//Go ahead up to the biggest possible string
				do{
					curBlockLen++;
					p++;
					curLineWidth+=m_iFontCharacterWidth[((unsigned char)*p)];
				}while((curLineWidth < maxWidth) && (curBlockLen < maxBlockLen));
				//Now overrunned , go back 1 char
				p--;
				curBlockLen--;
				//K...wrap
				ptr->text_blocks_ptr[ptr->num_text_blocks].block_len = curBlockLen;
				maxBlockLen-=curBlockLen;
				ptr->num_text_blocks++;
				ptr->text_blocks_ptr = (KviIrcViewTextBlock *)kvi_realloc(ptr->text_blocks_ptr,(ptr->num_text_blocks + 1) * sizeof(KviIrcViewTextBlock));

//				if(ptr->num_text_blocks >= KVI_IRCVIEW_MAX_TEXT_BLOCKS)return ptr->line_wraps;
				ptr->text_blocks_ptr[ptr->num_text_blocks].block_ptr = p;
				ptr->text_blocks_ptr[ptr->num_text_blocks].block_len = 0;
				ptr->text_blocks_ptr[ptr->num_text_blocks].block_width = 0;
				ptr->text_blocks_ptr[ptr->num_text_blocks].attr_ptr  = 0;
			} else {
				//found a space...
				//include it in the first block
				p++;
				curBlockLen++;
				//block width is not important : we wrap
				//significate block width
				ptr->text_blocks_ptr[ptr->num_text_blocks].block_len = curBlockLen;
				maxBlockLen-=curBlockLen;
				ptr->num_text_blocks++;
				ptr->text_blocks_ptr = (KviIrcViewTextBlock *)kvi_realloc(ptr->text_blocks_ptr,(ptr->num_text_blocks + 1) * sizeof(KviIrcViewTextBlock));
//				if(ptr->num_text_blocks >= KVI_IRCVIEW_MAX_TEXT_BLOCKS)return ptr->line_wraps;
				ptr->text_blocks_ptr[ptr->num_text_blocks].block_ptr = p;
				ptr->text_blocks_ptr[ptr->num_text_blocks].block_len = 0;
				ptr->text_blocks_ptr[ptr->num_text_blocks].block_width = 0;
				ptr->text_blocks_ptr[ptr->num_text_blocks].attr_ptr  = 0;
			}
			curLineWidth = 0;
			ptr->line_wraps++;
			if(ptr->line_wraps == 1){
				if(g_pOptions->m_bWrapMargin)maxWidth-=m_iWrapMargin;
			}
		}

	}
	ptr->num_text_blocks++;
//	return ptr->line_wraps;
}

//================= calculateSelectionBounds ==================//

void KviIrcView::calculateSelectionBounds()
{
	m_iSelectionTop    = ((m_iMouseButtonPressY < m_iMouseButtonCurrentY) ? m_iMouseButtonPressY : m_iMouseButtonCurrentY);
	m_iSelectionBottom = ((m_iMouseButtonPressY > m_iMouseButtonCurrentY) ? m_iMouseButtonPressY : m_iMouseButtonCurrentY);
	if(m_iMouseButtonPressY < m_iMouseButtonCurrentY){
		m_iSelectionBegin   = m_iMouseButtonPressX;
		m_iSelectionEnd  = m_iMouseButtonCurrentX;
	} else {
		m_iSelectionBegin   = m_iMouseButtonCurrentX;
		m_iSelectionEnd  = m_iMouseButtonPressX;
	}
	m_iSelectionLeft = (m_iSelectionBegin < m_iSelectionEnd) ? m_iSelectionBegin : m_iSelectionEnd;
	m_iSelectionRight = (m_iSelectionBegin > m_iSelectionEnd) ? m_iSelectionBegin : m_iSelectionEnd;

}

//============== checkForDoubleClickedUrl =================//

void KviIrcView::checkForDoubleClickedUrl(KviIrcViewTextLine * line,int left,int bottom,int bufIndex)
{
	__range_valid(bufIndex >= 0);
	int top = bottom-m_iFontLineSpacing;
	int right  = (line->text_blocks_ptr[bufIndex].block_width ? \
					left+line->text_blocks_ptr[bufIndex].block_width : width()-KVI_IRCVIEW_SCROLLBAR_AND_HORIZONTAL_BORDER_WIDTH);
	if((left < m_iMouseButtonPressX)&&(right > m_iMouseButtonPressX)&&
		(bottom > m_iMouseButtonPressY)&&(top < m_iMouseButtonPressY)){
		//Yeah man! This block clicked...check if it is a part of an url
		if(line->text_blocks_ptr[bufIndex].attr_ptr==0){
			//Could be a word wrapped url...go back until we find a block with attributes
			while((line->text_blocks_ptr[bufIndex].attr_ptr==0)&&(bufIndex > 0))bufIndex--;
		}
		if(bufIndex == 0)return; //Can't be...the first is always a color block
		if(line->text_blocks_ptr[bufIndex].attr_ptr){
			if(line->text_blocks_ptr[bufIndex].attr_ptr->attribute != KVI_TEXT_URL_HIGHLIGHT)return; //Can't be...
			//This block is the beginning of an url....
			m_szLastDoubleClickedUrl = KviStr(line->text_blocks_ptr[bufIndex].block_ptr,line->text_blocks_ptr[bufIndex].block_len);
			//Continue while we do not find a non word wrap block block
			for(;;){
				bufIndex++;
				if(bufIndex == line->num_text_blocks)return;
				if(line->text_blocks_ptr[bufIndex].attr_ptr)return; //finished
				KviStr szBlockData(line->text_blocks_ptr[bufIndex].block_ptr,line->text_blocks_ptr[bufIndex].block_len);
				m_szLastDoubleClickedUrl.append(szBlockData.ptr());
			}
		}
	}
}

//=============== checkSelectionBlock ===============//

bool KviIrcView::checkSelectionBlock(KviIrcViewTextLine * line,int left,int bottom,int bufIndex)
{
	register char *p=line->text_blocks_ptr[bufIndex].block_ptr;
	int top = bottom-m_iFontLineSpacing;
	int right  = (line->text_blocks_ptr[bufIndex].block_width ? \
					left+line->text_blocks_ptr[bufIndex].block_width : width()-KVI_IRCVIEW_SCROLLBAR_AND_HORIZONTAL_BORDER_WIDTH);
	if(bottom < m_iSelectionTop   )return false; //The selection starts under this line
	if(top    > m_iSelectionBottom)return false; //The selection ends over this line
	if((top    >= m_iSelectionTop)&&(bottom < m_iSelectionBottom)){
		//Whole line selected
		m_TextBlockSelectionInfo.selection_type = KVI_IRCVIEW_BLOCK_SELECTION_TOTAL;
		return true;
	}
	if((top    < m_iSelectionTop)&&(bottom >= m_iSelectionBottom)){
		//Selection begins and ends in this line
		if(right < m_iSelectionLeft)return false;
		if(left  > m_iSelectionRight)return false;
		if((right <= m_iSelectionRight) && (left > m_iSelectionLeft)){
			//Whole line selected
			m_TextBlockSelectionInfo.selection_type = KVI_IRCVIEW_BLOCK_SELECTION_TOTAL;
			return true;
		}
		if((right > m_iSelectionRight) && (left <= m_iSelectionLeft)){
			//Selection ends and begins in THIS BLOCK!
			m_TextBlockSelectionInfo.selection_type = KVI_IRCVIEW_BLOCK_SELECTION_CENTRAL;
			m_TextBlockSelectionInfo.part_1_length = 0;
			m_TextBlockSelectionInfo.part_1_width  = 0;
			while((left <= m_iSelectionLeft) && (m_TextBlockSelectionInfo.part_1_length < line->text_blocks_ptr[bufIndex].block_len)){
				left += m_iFontCharacterWidth[(unsigned char) *p];
				m_TextBlockSelectionInfo.part_1_width+=m_iFontCharacterWidth[(unsigned char) *p];
				p++;
				m_TextBlockSelectionInfo.part_1_length++;
			}
			//Need to include the first character
			if(m_TextBlockSelectionInfo.part_1_length > 0){
				m_TextBlockSelectionInfo.part_1_length--;
				p--;
				left -= m_iFontCharacterWidth[(unsigned char) *p];
				m_TextBlockSelectionInfo.part_1_width-=m_iFontCharacterWidth[(unsigned char) *p];
			}
			int maxLenNow = line->text_blocks_ptr[bufIndex].block_len-m_TextBlockSelectionInfo.part_1_length;
			int maxWidthNow = line->text_blocks_ptr[bufIndex].block_width-m_TextBlockSelectionInfo.part_1_width;
			m_TextBlockSelectionInfo.part_2_length = 0;
			m_TextBlockSelectionInfo.part_2_width  = 0;
			while((left < m_iSelectionRight) && (m_TextBlockSelectionInfo.part_2_length < maxLenNow)){
				left += m_iFontCharacterWidth[(unsigned char) *p];
				m_TextBlockSelectionInfo.part_2_width+=m_iFontCharacterWidth[(unsigned char) *p];
				p++;
				m_TextBlockSelectionInfo.part_2_length++;
			}		
			m_TextBlockSelectionInfo.part_3_length = maxLenNow-m_TextBlockSelectionInfo.part_2_length;
			m_TextBlockSelectionInfo.part_3_width  = maxWidthNow-m_TextBlockSelectionInfo.part_2_width;
			return true;
		}
		if(right > m_iSelectionRight){
			//Selection ends in THIS BLOCK!
			m_TextBlockSelectionInfo.selection_type = KVI_IRCVIEW_BLOCK_SELECTION_LEFT;
			m_TextBlockSelectionInfo.part_1_length = 0;
			m_TextBlockSelectionInfo.part_1_width  = 0;
			while((left < m_iSelectionRight) && (m_TextBlockSelectionInfo.part_1_length < line->text_blocks_ptr[bufIndex].block_len)){
				left += m_iFontCharacterWidth[(unsigned char) *p];
				m_TextBlockSelectionInfo.part_1_width+=m_iFontCharacterWidth[(unsigned char) *p];
				p++;
				m_TextBlockSelectionInfo.part_1_length++;
			}
			m_TextBlockSelectionInfo.part_2_length = line->text_blocks_ptr[bufIndex].block_len-m_TextBlockSelectionInfo.part_1_length;
			m_TextBlockSelectionInfo.part_2_width  = line->text_blocks_ptr[bufIndex].block_width-m_TextBlockSelectionInfo.part_1_width;
			return true;
		}
		//Selection begins in THIS BLOCK!
		m_TextBlockSelectionInfo.selection_type = KVI_IRCVIEW_BLOCK_SELECTION_RIGHT;
		m_TextBlockSelectionInfo.part_1_length = 0;
		m_TextBlockSelectionInfo.part_1_width  = 0;
		while((left <= m_iSelectionLeft) && (m_TextBlockSelectionInfo.part_1_length < line->text_blocks_ptr[bufIndex].block_len)){
			left += m_iFontCharacterWidth[(unsigned char) *p];
			m_TextBlockSelectionInfo.part_1_width+=m_iFontCharacterWidth[(unsigned char) *p];
			p++;
			m_TextBlockSelectionInfo.part_1_length++;
		}
		//Need to include the first character
		if(m_TextBlockSelectionInfo.part_1_length > 0){
			m_TextBlockSelectionInfo.part_1_length--;
			p--;
			left -= m_iFontCharacterWidth[(unsigned char) *p];
			m_TextBlockSelectionInfo.part_1_width-=m_iFontCharacterWidth[(unsigned char) *p];
		}
		m_TextBlockSelectionInfo.part_2_length = line->text_blocks_ptr[bufIndex].block_len-m_TextBlockSelectionInfo.part_1_length;
		m_TextBlockSelectionInfo.part_2_width  = line->text_blocks_ptr[bufIndex].block_width-m_TextBlockSelectionInfo.part_1_width;
		return true;
	}

	if(top < m_iSelectionTop){
		//Selection starts in this line
		if(right < m_iSelectionBegin)return false;
		if(left > m_iSelectionBegin){
			//Whole block selected
			m_TextBlockSelectionInfo.selection_type = KVI_IRCVIEW_BLOCK_SELECTION_TOTAL;
			return true;
		}
		//Selection begins in THIS BLOCK!
		m_TextBlockSelectionInfo.selection_type = KVI_IRCVIEW_BLOCK_SELECTION_RIGHT;
		m_TextBlockSelectionInfo.part_1_length = 0;
		m_TextBlockSelectionInfo.part_1_width  = 0;
		while((left <= m_iSelectionBegin) && (m_TextBlockSelectionInfo.part_1_length < line->text_blocks_ptr[bufIndex].block_len)){
			left += m_iFontCharacterWidth[(unsigned char) *p];
			m_TextBlockSelectionInfo.part_1_width+=m_iFontCharacterWidth[(unsigned char) *p];
			p++;
			m_TextBlockSelectionInfo.part_1_length++;
		}
		//Need to include the first character
		if(m_TextBlockSelectionInfo.part_1_length > 0){
			m_TextBlockSelectionInfo.part_1_length--;
			p--;
			left -= m_iFontCharacterWidth[(unsigned char) *p];
			m_TextBlockSelectionInfo.part_1_width-=m_iFontCharacterWidth[(unsigned char) *p];
		}
		m_TextBlockSelectionInfo.part_2_length = line->text_blocks_ptr[bufIndex].block_len-m_TextBlockSelectionInfo.part_1_length;
		m_TextBlockSelectionInfo.part_2_width  = line->text_blocks_ptr[bufIndex].block_width-m_TextBlockSelectionInfo.part_1_width;
		return true;
	}
	//Selection ends in this line
	if(left  > m_iSelectionEnd)return false;
	if(right < m_iSelectionEnd){
		//Whole block selected
		m_TextBlockSelectionInfo.selection_type = KVI_IRCVIEW_BLOCK_SELECTION_TOTAL;
		return true;
	}
	//Selection ends in THIS BLOCK!
	m_TextBlockSelectionInfo.selection_type = KVI_IRCVIEW_BLOCK_SELECTION_LEFT;
	m_TextBlockSelectionInfo.part_1_length = 0;
	m_TextBlockSelectionInfo.part_1_width  = 0;
	while((left < m_iSelectionEnd) && (m_TextBlockSelectionInfo.part_1_length < line->text_blocks_ptr[bufIndex].block_len)){
		left += m_iFontCharacterWidth[(unsigned char) *p];
		m_TextBlockSelectionInfo.part_1_width+=m_iFontCharacterWidth[(unsigned char) *p];
		p++;
		m_TextBlockSelectionInfo.part_1_length++;
	}
	m_TextBlockSelectionInfo.part_2_length = line->text_blocks_ptr[bufIndex].block_len-m_TextBlockSelectionInfo.part_1_length;
	m_TextBlockSelectionInfo.part_2_width  = line->text_blocks_ptr[bufIndex].block_width-m_TextBlockSelectionInfo.part_1_width;
	return true;
}

//============ recalcFontVariables ==============//

void KviIrcView::recalcFontVariables(const QFont &fnt)
{
	QFontMetrics fm(font());
	m_iFontLineSpacing = fm.lineSpacing();
	if(m_iFontLineSpacing < 16)m_iFontLineSpacing = 16;
	m_iFontDescent     =fm.descent();
	m_iFontLineWidth   =fm.lineWidth();
	if(m_iFontLineWidth==0)m_iFontLineWidth=1;
	m_iWrapMargin = fm.width("wwww");
	for(int i=0;i<256;i++)m_iFontCharacterWidth[i]=fm.width((char)i);
}

//================ resizeEvent ===============//

void KviIrcView::resizeMemBuffer()
{
//	bool bDirty = false;
//	int w = g_pIrcViewMemBuffer->width();
//	int h = g_pIrcViewMemBuffer->height();
//	if(w < (width() - KVI_IRCVIEW_SCROLLBAR_WIDTH)){
//		w = width() - KVI_IRCVIEW_SCROLLBAR_WIDTH;
//		bDirty = true;
//	} else {
//		if(h < height()){
//			h = height();
//			bDirty = true;
//		}
//	}
//	
//	if(bDirty)g_pIrcViewMemBuffer->resize(w,h);
//	g_hIrcViewMemBuffer = g_pIrcViewMemBuffer->handle(); // Qt may change it while resizing ?

	// check if we can make the mem buffer a bit smaller (save some memory)
	int maxw = 16;
	int maxh = 16;
	for(KviIrcView *i=g_pIrcViewWidgetList->first();i;i=g_pIrcViewWidgetList->next()){
		if((i->width() - KVI_IRCVIEW_SCROLLBAR_WIDTH) > maxw)maxw = i->width() - KVI_IRCVIEW_SCROLLBAR_WIDTH;
		if(i->height() > maxh)maxh = i->height();
	}
	if((maxw != g_pIrcViewMemBuffer->width())||(maxh != g_pIrcViewMemBuffer->height())){
		g_pIrcViewMemBuffer->resize(maxw,maxh);
		g_hIrcViewMemBuffer = g_pIrcViewMemBuffer->handle(); // Qt may change it while resizing
//		debug("resize mem buffer %d,%d",maxw,maxh);
	}

	// Ok....mem buffer is big enough for all the irc views alive
}

void KviIrcView::resizeEvent(QResizeEvent *)
{
//	m_pMemBuffer->resize(width()-KVI_IRCVIEW_SCROLLBAR_WIDTH,height());
	resizeMemBuffer();
	m_pScrollBar->setGeometry(width()-KVI_IRCVIEW_SCROLLBAR_WIDTH,0,KVI_IRCVIEW_SCROLLBAR_WIDTH,height());
}

//================ mousePressEvent ================//

void KviIrcView::mousePressEvent(QMouseEvent *e)
{
	m_iMouseButtonPressX=e->pos().x();
	m_iMouseButtonPressY=e->pos().y();
	m_iMouseButtonCurrentX=e->pos().x();
	m_iMouseButtonCurrentY=e->pos().y();
	if(e->button() & LeftButton)m_bSelecting=true;
	else if(e->button() & RightButton){
		if(e->state() & ControlButton)m_pFrm->windowPopupRequested(this,m_pKviWindow);
		else emit contextPopupRequested(this);
	} else if(e->button() & MidButton)m_pFrm->windowPopupRequested(this,m_pKviWindow);
}

//================ mouseReleaseEvent ===============//

void KviIrcView::mouseReleaseEvent(QMouseEvent *)
{
	if(m_iSelectTimer){
		killTimer(m_iSelectTimer);
		m_iSelectTimer = 0;
		m_pFrm->ircViewTextSelected(this,m_pKviWindow,m_szLastSelection.ptr());
	}
	if(m_bSelecting){
		m_bSelecting=false;
		paintEvent(0);
	}
}

//=============== mouseMoveEvent ==================//

void KviIrcView::mouseMoveEvent(QMouseEvent *e)
{
	if(m_bSelecting){
		if(m_iSelectTimer == 0)m_iSelectTimer = startTimer(KVI_IRCVIEW_SELECT_REPAINT_INTERVAL);
	} else if(m_iSelectTimer){
		killTimer(m_iSelectTimer);
		m_iSelectTimer = 0;
	}
}

//=============== timerEvent ===============//

void KviIrcView::timerEvent(QTimerEvent *e)
{
	if(e->timerId() == m_iSelectTimer){
		QPoint pnt = mapFromGlobal(QCursor::pos());
		m_iMouseButtonCurrentX=pnt.x();
		m_iMouseButtonCurrentY=pnt.y();
		calculateSelectionBounds();
		paintEvent(0);
	}
}

//=============== leaveEvent ===============//

//void KviIrcView::leaveEvent(QEvent *)
//{
//	if(m_bSelecting)mouseReleaseEvent(0);
//}

//============= mouseDoubleClickEvent ===============//

void KviIrcView::mouseDoubleClickEvent(QMouseEvent *e)
{
	m_iMouseButtonPressX=e->pos().x();
	m_iMouseButtonPressY=e->pos().y();
	m_bSelecting = true;
	m_bDoubleClicked = true;
	paintEvent(0);
	m_bDoubleClicked = false;
	m_bSelecting = false;
	if(m_szLastDoubleClickedUrl.isEmpty())return;
	if(m_pFrm)m_pFrm->urlDoubleClicked(m_szLastDoubleClickedUrl);
//	emit urlDoubleClicked(m_szLastDoubleClickedUrl.ptr());
}

//=============== fontChange ================//

void KviIrcView::fontChange(const QFont &oldFont)
{
	//Do not update
	recalcFontVariables(font());
	// force to recalculate all the wraps in the next repaint
	KviIrcViewTextLine * l = m_pFirstLine;
	while(l){
		l->max_line_width = -1;
		l = l->next_line;
	}
}

#include "m_kvi_ircview.moc"
