//
//   File : kvi_madness.cpp (/usr/build/NEW_kvirc/kvirc/src/kvirc/kvi_madness.cpp)
//   Last major modification : Sat Mar 27 1999 16:30:34 by Szymon Stefanek
//
//   This file is part of the KVirc irc client distribution
//   Copyright (C) 1999-2000 Szymon Stefanek (stefanek@tin.it)
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

#define _KVI_MADNESS_CPP_

#include "kvi_madness.h"

#include "kvi_settings.h"
#include "kvi_defines.h"
#include "kvi_debug.h"

#include <qwidget.h>
#include <qpixmap.h>
#include <qnamespace.h>

#include <stdlib.h>

#include <X11/Xlib.h>

#ifdef COMPILE_MADNESS


void kvi_madnessForWidget(QWidget *w)
{
	Display *dpy=w->x11Display();
	XGCValues gcval;
	HANDLE hWnd=w->handle();
	// kill exposures
	gcval.graphics_exposures = false;
	gcval.subwindow_mode = IncludeInferiors;
	// choose a random raster operation
//	int r = (1+(int) (((double)100)*rand()/RAND_MAX+1.0))%3;
//	switch(r){
//		case 0: gcval.function = GXcopy; break;
//		case 1: gcval.function = GXcopy; break;
//		case 2: gcval.function = GXor;   break;
//	}
	GC gc_aux = XCreateGC(dpy,hWnd,GCGraphicsExposures|GCSubwindowMode,&gcval);
	// fixed random direction for vertical and horizontal blur : 1 right or down ,-1 left or up
	int direction = ((((int) (((double)w->width())*rand()/(RAND_MAX+1.0))) % 2)==1) ? 1 : -1;
	// multidirectional , vertical or horizontal ?
	int type = ((int) ( ((double)w->width()) * rand()/(RAND_MAX+1.0) ) ) % 3;
	int x1,y1,x2,y2,dX,dY;
	for(int i=0;i<KVI_MADNESS_LOOP_TIMES;i++){
		x2=1+(int) (((double)w->width())*rand()/(RAND_MAX+1.0)); 
		x1=1+(int) (((double)x2)*rand()/(RAND_MAX+1.0)); 
		y2=1+(int) (((double)w->height())*rand()/(RAND_MAX+1.0)); 
		y1=1+(int) (((double)y2)*rand()/(RAND_MAX+1.0)); 	
		dX = ((x2 & 1)==1) ? 1 : -1;
		dY = ((x1 & 1)==1) ? 1 : -1;
		switch(type){
			case 0: XCopyArea(dpy,hWnd,hWnd,gc_aux,x1,y1,x2-x1,y2-y1,x1+dX,y1+dY); break;
			case 1: XCopyArea(dpy,hWnd,hWnd,gc_aux,x1,y1,x2-x1,y2-y1,x1+direction,y1+dY); break;
			case 2: XCopyArea(dpy,hWnd,hWnd,gc_aux,x1,y1,x2-x1,y2-y1,x1+dX,y1+direction); break;
		}
	}
	XFreeGC(dpy,gc_aux);
}

#else

void kvi_madnessForWidget(QWidget *w)
{
//	debug("Sorry : no madness available.");
}

#endif //!COMPILE_MADNESS
