#ifndef _KVI_SCRIPTEDITOR_H_INCLUDED_
#define _KVI_SCRIPTEDITOR_H_INCLUDED_

//
//   File : kvi_scripteditor.h (/usr/build/NEW_kvirc/kvirc/src/kvirc/kvi_scripteditor.h)
//   Last major modification : Sun Mar 28 1999 16:11:48 by Szymon Stefanek
//
//   This file is part of the KVirc irc client distribution
//   Copyright (C) 1999-2000 Szymon Stefanek (stefanek@tin.it)
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

#include <qmultilineedit.h>
#include <qpixmap.h>
#include <qpopupmenu.h>
#include <qfontmetrics.h>
#include <qglobal.h>

class KviScriptEditor : public QMultiLineEdit
{
	Q_OBJECT
public:
	KviScriptEditor(QWidget *parent);
	~KviScriptEditor();
private:
	QPixmap * m_pMemBuffer;
	int m_spaceWidth;
	int m_textState;
	QPopupMenu * m_pContextPopup;
	QFontMetrics * m_pFm;
protected:
	int textWidthWithTabs(const char *s,int nChars);
	QColor getColor(const char *s,int len);
	int extractNextWord(const char *s);
	int getSpacesAndTabsLen(const char *s,int nChars,int curNChars,int *width);
	virtual void paintCell(QPainter * painter,int row,int col);
	virtual void resizeEvent(QResizeEvent *e);
	virtual void setFont(const QFont &font);
	virtual void mousePressEvent(QMouseEvent *e);
};

#endif //!_KVI_SCRIPTEDITOR_H_INCLUDED_
