#ifndef _KVI_WMDOCK_H_INCLUDED_
#define _KVI_WMDOCK_H_INCLUDED_

//
//   This file is part of the KVirc irc client distribution
//   Copyright (C) 1999-2000 Szymon Stefanek (stefanek@tin.it)
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

#include <qwidget.h>
#include <qpopupmenu.h>
#include <qpixmap.h>

class KviWMDockWidget : public QWidget
{
	friend class KviApp;
	Q_OBJECT
public:
	KviWMDockWidget();
	~KviWMDockWidget();
protected:
	bool m_bFramesVisible;
	QPopupMenu * m_pContextPopup;
	bool m_bHighlight;
	bool m_bAltColor;
	QPixmap * m_pNormalIcon;
	QPixmap * m_pHighlightIcon;
	QPixmap * m_pAltColorIcon;
protected:
	inline bool framesVisible(){ return m_bFramesVisible; };
	void setFramesVisible(bool bVisible);
	virtual void mousePressEvent(QMouseEvent *e);
	void highlight(bool bAltColor);
	virtual void paintEvent(QPaintEvent *e);
};


#endif //_KVI_WMDOCK_H_INCLUDED_
